/* Autogenerated by cpybuilder */
#include <Python.h>
#include "gcc-python.h"
#include "gcc-python-wrappers.h"
#include "gcc-plugin.h"
#include "tree.h"
#include "function.h"
#include "basic-block.h"
#include "c-family/c-common.h"

/**** Prototypes ****/


/**** Definitions ****/


static PyObject *
gcc_Tree_get_type(struct PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(TREE_TYPE(self->t));
}

static PyObject *
gcc_Tree_get_addr(struct PyGccTree *self, void *closure)
{
    return PyLong_FromVoidPtr(self->t);
}

static PyGetSetDef gcc_Tree_getset_table[] = {
    {"type",
     (getter)gcc_Tree_get_type,
     (setter)NULL,
     "Instance of gcc.Tree giving the type of the node",
     NULL},
    {"addr",
     (getter)gcc_Tree_get_addr,
     (setter)NULL,
     "The address of the underlying GCC object in memory",
     NULL},
    {"str_no_uid",
     (getter)gcc_Tree_get_str_no_uid,
     (setter)NULL,
     "A string representation of this object, like str(), but without including any internal UID",
     NULL},
    {NULL}  /* Sentinel */
};

PyObject*
gcc_Tree_debug(PyObject *self, PyObject *args)
{
    PyGccTree *tree_obj;
    /* FIXME: type checking */
    tree_obj = (PyGccTree *)self;
    debug_tree(tree_obj->t);
    Py_RETURN_NONE;
}
static PyMethodDef gcc_Tree_methods[] = {
    {"debug",  gcc_Tree_debug, METH_VARARGS,
     "Dump the tree to stderr"},
    {NULL, NULL, 0, NULL} /* Sentinel */
};

PyGccWrapperTypeObject gcc_TreeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.Tree", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = gcc_python_wrapper_dealloc,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = (hashfunc)gcc_Tree_hash,
            .tp_call = NULL,
            .tp_str = (reprfunc)gcc_Tree_str,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = gcc_Tree_richcompare,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = gcc_Tree_methods,
            .tp_members = NULL,
            .tp_getset = gcc_Tree_getset_table,
            .tp_base = (PyTypeObject*)NULL,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyMethodDef gcc_Statement_methods[] = {
    {NULL, NULL, 0, NULL} /* Sentinel */
};
static PyGetSetDef gcc_Statement_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_StatementType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.Statement", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = gcc_Statement_methods,
            .tp_members = NULL,
            .tp_getset = gcc_Statement_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_Unary_get_operand(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(TREE_OPERAND (self->t, 0));
}

static PyObject *
gcc_Unary_get_location(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_location(EXPR_LOCATION(self->t));
}

static PyMethodDef gcc_Unary_methods[] = {
    {"get_symbol",  gcc_Tree_get_symbol, METH_CLASS|METH_NOARGS,
     "FIXME"},
    {NULL, NULL, 0, NULL} /* Sentinel */
};
static PyGetSetDef gcc_Unary_getset_table[] = {
    {"operand",
     (getter)gcc_Unary_get_operand,
     (setter)NULL,
     "The operand of this expression, as a gcc.Tree",
     NULL},
    {"location",
     (getter)gcc_Unary_get_location,
     (setter)NULL,
     "The source location of this expression",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_UnaryType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.Unary", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = gcc_Unary_methods,
            .tp_members = NULL,
            .tp_getset = gcc_Unary_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_Binary_get_location(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_location(EXPR_LOCATION(self->t));
}

static PyMethodDef gcc_Binary_methods[] = {
    {"get_symbol",  gcc_Tree_get_symbol, METH_CLASS|METH_NOARGS,
     "FIXME"},
    {NULL, NULL, 0, NULL} /* Sentinel */
};
static PyGetSetDef gcc_Binary_getset_table[] = {
    {"location",
     (getter)gcc_Binary_get_location,
     (setter)NULL,
     "The source location of this expression",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_BinaryType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.Binary", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = gcc_Binary_methods,
            .tp_members = NULL,
            .tp_getset = gcc_Binary_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyMethodDef gcc_Constant_methods[] = {
    {NULL, NULL, 0, NULL} /* Sentinel */
};
static PyGetSetDef gcc_Constant_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ConstantType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.Constant", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = gcc_Constant_methods,
            .tp_members = NULL,
            .tp_getset = gcc_Constant_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyMethodDef gcc_VlExp_methods[] = {
    {NULL, NULL, 0, NULL} /* Sentinel */
};
static PyGetSetDef gcc_VlExp_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_VlExpType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.VlExp", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = gcc_VlExp_methods,
            .tp_members = NULL,
            .tp_getset = gcc_VlExp_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_Comparison_get_location(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_location(EXPR_LOCATION(self->t));
}

static PyMethodDef gcc_Comparison_methods[] = {
    {"get_symbol",  gcc_Tree_get_symbol, METH_CLASS|METH_NOARGS,
     "FIXME"},
    {NULL, NULL, 0, NULL} /* Sentinel */
};
static PyGetSetDef gcc_Comparison_getset_table[] = {
    {"location",
     (getter)gcc_Comparison_get_location,
     (setter)NULL,
     "The source location of this expression",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ComparisonType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.Comparison", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = gcc_Comparison_methods,
            .tp_members = NULL,
            .tp_getset = gcc_Comparison_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};


PyObject *
gcc_Declaration_get_name(struct PyGccTree *self, void *closure)
{
    if (DECL_NAME(self->t)) {
        return gcc_python_string_from_string(IDENTIFIER_POINTER (DECL_NAME (self->t)));
    }
    Py_RETURN_NONE;
}

static PyObject *
gcc_Declaration_get_location(struct PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_location(DECL_SOURCE_LOCATION(self->t));
}
static PyMethodDef gcc_Declaration_methods[] = {
    {NULL, NULL, 0, NULL} /* Sentinel */
};
static PyGetSetDef gcc_Declaration_getset_table[] = {
    {"name",
     (getter)gcc_Declaration_get_name,
     (setter)NULL,
     "The name of this declaration (string)",
     NULL},
    {"location",
     (getter)gcc_Declaration_get_location,
     (setter)NULL,
     "The gcc.Location for this declaration",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_DeclarationType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.Declaration", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = (reprfunc)gcc_Declaration_repr,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = gcc_Declaration_methods,
            .tp_members = NULL,
            .tp_getset = gcc_Declaration_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_Expression_get_location(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_location(EXPR_LOCATION(self->t));
}

static PyMethodDef gcc_Expression_methods[] = {
    {"get_symbol",  gcc_Tree_get_symbol, METH_CLASS|METH_NOARGS,
     "FIXME"},
    {NULL, NULL, 0, NULL} /* Sentinel */
};
static PyGetSetDef gcc_Expression_getset_table[] = {
    {"location",
     (getter)gcc_Expression_get_location,
     (setter)NULL,
     "The source location of this expression",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ExpressionType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.Expression", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = gcc_Expression_methods,
            .tp_members = NULL,
            .tp_getset = gcc_Expression_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_Reference_get_location(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_location(EXPR_LOCATION(self->t));
}

static PyMethodDef gcc_Reference_methods[] = {
    {"get_symbol",  gcc_Tree_get_symbol, METH_CLASS|METH_NOARGS,
     "FIXME"},
    {NULL, NULL, 0, NULL} /* Sentinel */
};
static PyGetSetDef gcc_Reference_getset_table[] = {
    {"location",
     (getter)gcc_Reference_get_location,
     (setter)NULL,
     "The source location of this expression",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ReferenceType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.Reference", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = gcc_Reference_methods,
            .tp_members = NULL,
            .tp_getset = gcc_Reference_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_Type_get_name(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(TYPE_NAME(self->t));
}

static PyObject *
gcc_Type_get_pointer(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(build_pointer_type(self->t));
}


PyObject*
gcc_Type_get_char(PyObject *cls, PyObject *args)
{
    return gcc_python_make_wrapper_tree(integer_types[itk_char]);
}

PyObject*
gcc_Type_get_signed_char(PyObject *cls, PyObject *args)
{
    return gcc_python_make_wrapper_tree(integer_types[itk_signed_char]);
}

PyObject*
gcc_Type_get_unsigned_char(PyObject *cls, PyObject *args)
{
    return gcc_python_make_wrapper_tree(integer_types[itk_unsigned_char]);
}

PyObject*
gcc_Type_get_short(PyObject *cls, PyObject *args)
{
    return gcc_python_make_wrapper_tree(integer_types[itk_short]);
}

PyObject*
gcc_Type_get_unsigned_short(PyObject *cls, PyObject *args)
{
    return gcc_python_make_wrapper_tree(integer_types[itk_unsigned_short]);
}

PyObject*
gcc_Type_get_int(PyObject *cls, PyObject *args)
{
    return gcc_python_make_wrapper_tree(integer_types[itk_int]);
}

PyObject*
gcc_Type_get_unsigned_int(PyObject *cls, PyObject *args)
{
    return gcc_python_make_wrapper_tree(integer_types[itk_unsigned_int]);
}

PyObject*
gcc_Type_get_long(PyObject *cls, PyObject *args)
{
    return gcc_python_make_wrapper_tree(integer_types[itk_long]);
}

PyObject*
gcc_Type_get_unsigned_long(PyObject *cls, PyObject *args)
{
    return gcc_python_make_wrapper_tree(integer_types[itk_unsigned_long]);
}

PyObject*
gcc_Type_get_long_long(PyObject *cls, PyObject *args)
{
    return gcc_python_make_wrapper_tree(integer_types[itk_long_long]);
}

PyObject*
gcc_Type_get_unsigned_long_long(PyObject *cls, PyObject *args)
{
    return gcc_python_make_wrapper_tree(integer_types[itk_unsigned_long_long]);
}

PyObject*
gcc_Type_get_int128(PyObject *cls, PyObject *args)
{
    return gcc_python_make_wrapper_tree(integer_types[itk_int128]);
}

PyObject*
gcc_Type_get_unsigned_int128(PyObject *cls, PyObject *args)
{
    return gcc_python_make_wrapper_tree(integer_types[itk_unsigned_int128]);
}

PyObject*
gcc_Type_get_uint32(PyObject *cls, PyObject *args)
{
    return gcc_python_make_wrapper_tree(global_trees[TI_UINT32_TYPE]);
}

PyObject*
gcc_Type_get_uint64(PyObject *cls, PyObject *args)
{
    return gcc_python_make_wrapper_tree(global_trees[TI_UINT64_TYPE]);
}

PyObject*
gcc_Type_get_float(PyObject *cls, PyObject *args)
{
    return gcc_python_make_wrapper_tree(global_trees[TI_FLOAT_TYPE]);
}

PyObject*
gcc_Type_get_double(PyObject *cls, PyObject *args)
{
    return gcc_python_make_wrapper_tree(global_trees[TI_DOUBLE_TYPE]);
}

PyObject*
gcc_Type_get_long_double(PyObject *cls, PyObject *args)
{
    return gcc_python_make_wrapper_tree(global_trees[TI_LONG_DOUBLE_TYPE]);
}

PyObject*
gcc_Type_get_void(PyObject *cls, PyObject *args)
{
    return gcc_python_make_wrapper_tree(global_trees[TI_VOID_TYPE]);
}

PyObject*
gcc_Type_get_size_t(PyObject *cls, PyObject *args)
{
    return gcc_python_make_wrapper_tree(global_trees[TI_SIZE_TYPE]);
}
static PyMethodDef gcc_Type_methods[] = {
    {"char",  gcc_Type_get_char, METH_CLASS|METH_NOARGS,
     "The builtin type 'char' as a gcc.Type (or None at startup before any compilation passes)"},
    {"signed_char",  gcc_Type_get_signed_char, METH_CLASS|METH_NOARGS,
     "The builtin type 'signed char' as a gcc.Type (or None at startup before any compilation passes)"},
    {"unsigned_char",  gcc_Type_get_unsigned_char, METH_CLASS|METH_NOARGS,
     "The builtin type 'unsigned char' as a gcc.Type (or None at startup before any compilation passes)"},
    {"short",  gcc_Type_get_short, METH_CLASS|METH_NOARGS,
     "The builtin type 'short' as a gcc.Type (or None at startup before any compilation passes)"},
    {"unsigned_short",  gcc_Type_get_unsigned_short, METH_CLASS|METH_NOARGS,
     "The builtin type 'unsigned short' as a gcc.Type (or None at startup before any compilation passes)"},
    {"int",  gcc_Type_get_int, METH_CLASS|METH_NOARGS,
     "The builtin type 'int' as a gcc.Type (or None at startup before any compilation passes)"},
    {"unsigned_int",  gcc_Type_get_unsigned_int, METH_CLASS|METH_NOARGS,
     "The builtin type 'unsigned int' as a gcc.Type (or None at startup before any compilation passes)"},
    {"long",  gcc_Type_get_long, METH_CLASS|METH_NOARGS,
     "The builtin type 'long' as a gcc.Type (or None at startup before any compilation passes)"},
    {"unsigned_long",  gcc_Type_get_unsigned_long, METH_CLASS|METH_NOARGS,
     "The builtin type 'unsigned long' as a gcc.Type (or None at startup before any compilation passes)"},
    {"long_long",  gcc_Type_get_long_long, METH_CLASS|METH_NOARGS,
     "The builtin type 'long long' as a gcc.Type (or None at startup before any compilation passes)"},
    {"unsigned_long_long",  gcc_Type_get_unsigned_long_long, METH_CLASS|METH_NOARGS,
     "The builtin type 'unsigned long long' as a gcc.Type (or None at startup before any compilation passes)"},
    {"int128",  gcc_Type_get_int128, METH_CLASS|METH_NOARGS,
     "The builtin type 'int128' as a gcc.Type (or None at startup before any compilation passes)"},
    {"unsigned_int128",  gcc_Type_get_unsigned_int128, METH_CLASS|METH_NOARGS,
     "The builtin type 'unsigned int128' as a gcc.Type (or None at startup before any compilation passes)"},
    {"uint32",  gcc_Type_get_uint32, METH_CLASS|METH_NOARGS,
     "The builtin type 'uint32' as a gcc.Type (or None at startup before any compilation passes)"},
    {"uint64",  gcc_Type_get_uint64, METH_CLASS|METH_NOARGS,
     "The builtin type 'uint64' as a gcc.Type (or None at startup before any compilation passes)"},
    {"float",  gcc_Type_get_float, METH_CLASS|METH_NOARGS,
     "The builtin type 'float' as a gcc.Type (or None at startup before any compilation passes)"},
    {"double",  gcc_Type_get_double, METH_CLASS|METH_NOARGS,
     "The builtin type 'double' as a gcc.Type (or None at startup before any compilation passes)"},
    {"long_double",  gcc_Type_get_long_double, METH_CLASS|METH_NOARGS,
     "The builtin type 'long double' as a gcc.Type (or None at startup before any compilation passes)"},
    {"void",  gcc_Type_get_void, METH_CLASS|METH_NOARGS,
     "The builtin type 'void' as a gcc.Type (or None at startup before any compilation passes)"},
    {"size_t",  gcc_Type_get_size_t, METH_CLASS|METH_NOARGS,
     "The builtin type 'size_t' as a gcc.Type (or None at startup before any compilation passes)"},
    {NULL, NULL, 0, NULL} /* Sentinel */
};
static PyGetSetDef gcc_Type_getset_table[] = {
    {"name",
     (getter)gcc_Type_get_name,
     (setter)NULL,
     "The name of the type as a gcc.Tree, or None",
     NULL},
    {"pointer",
     (getter)gcc_Type_get_pointer,
     (setter)NULL,
     "The gcc.PointerType representing '(this_type *)'",
     NULL},
    {"attributes",
     (getter)gcc_Type_get_attributes,
     (setter)NULL,
     "The user-defined attributes on this type",
     NULL},
    {"sizeof",
     (getter)gcc_Type_get_sizeof,
     (setter)NULL,
     "sizeof() this type, as a gcc.IntegerCst",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TypeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.Type", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = gcc_Type_methods,
            .tp_members = NULL,
            .tp_getset = gcc_Type_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ErrorMark_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ErrorMarkType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ErrorMark", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ErrorMark_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_IdentifierNode_get_name(PyGccTree *self, void *closure)
{
    return gcc_python_string_or_none(IDENTIFIER_POINTER(self->t));
}

static PyGetSetDef gcc_IdentifierNode_getset_table[] = {
    {"name",
     (getter)gcc_IdentifierNode_get_name,
     (setter)NULL,
     "The name of this gcc.IdentifierNode, as a string",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_IdentifierNodeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.IdentifierNode", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = (reprfunc)gcc_IdentifierNode_repr,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_IdentifierNode_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TreeList_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TreeListType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TreeList", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = (reprfunc)gcc_TreeList_repr,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TreeList_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TreeVec_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TreeVecType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TreeVec", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TreeVec_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_Block_get_vars(PyGccTree *self, void *closure)
{
    return gcc_tree_list_from_chain(BLOCK_VARS(self->t));
}

static PyGetSetDef gcc_Block_getset_table[] = {
    {"vars",
     (getter)gcc_Block_get_vars,
     (setter)NULL,
     "The list of gcc.Tree for the declarations and labels in this block",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_BlockType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.Block", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_Block_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_OffsetType_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_OffsetTypeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.OffsetType", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_OffsetType_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_EnumeralType_get_const(PyGccTree *self, void *closure)
{
    return PyBool_FromLong(TYPE_QUALS(self->t) & TYPE_QUAL_CONST);
}

static PyObject *
gcc_EnumeralType_get_const_equivalent(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(build_qualified_type(self->t, TYPE_QUAL_CONST));
}

static PyObject *
gcc_EnumeralType_get_volatile(PyGccTree *self, void *closure)
{
    return PyBool_FromLong(TYPE_QUALS(self->t) & TYPE_QUAL_VOLATILE);
}

static PyObject *
gcc_EnumeralType_get_volatile_equivalent(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(build_qualified_type(self->t, TYPE_QUAL_VOLATILE));
}

static PyObject *
gcc_EnumeralType_get_restrict(PyGccTree *self, void *closure)
{
    return PyBool_FromLong(TYPE_QUALS(self->t) & TYPE_QUAL_RESTRICT);
}

static PyObject *
gcc_EnumeralType_get_restrict_equivalent(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(build_qualified_type(self->t, TYPE_QUAL_RESTRICT));
}

static PyGetSetDef gcc_EnumeralType_getset_table[] = {
    {"const",
     (getter)gcc_EnumeralType_get_const,
     (setter)NULL,
     "Boolean: does this type have the 'const' modifier?",
     NULL},
    {"const_equivalent",
     (getter)gcc_EnumeralType_get_const_equivalent,
     (setter)NULL,
     "The gcc.Type for the const version of this type",
     NULL},
    {"volatile",
     (getter)gcc_EnumeralType_get_volatile,
     (setter)NULL,
     "Boolean: does this type have the 'volatile' modifier?",
     NULL},
    {"volatile_equivalent",
     (getter)gcc_EnumeralType_get_volatile_equivalent,
     (setter)NULL,
     "The gcc.Type for the volatile version of this type",
     NULL},
    {"restrict",
     (getter)gcc_EnumeralType_get_restrict,
     (setter)NULL,
     "Boolean: does this type have the 'restrict' modifier?",
     NULL},
    {"restrict_equivalent",
     (getter)gcc_EnumeralType_get_restrict_equivalent,
     (setter)NULL,
     "The gcc.Type for the restrict version of this type",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_EnumeralTypeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.EnumeralType", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_EnumeralType_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_BooleanType_get_const(PyGccTree *self, void *closure)
{
    return PyBool_FromLong(TYPE_QUALS(self->t) & TYPE_QUAL_CONST);
}

static PyObject *
gcc_BooleanType_get_const_equivalent(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(build_qualified_type(self->t, TYPE_QUAL_CONST));
}

static PyObject *
gcc_BooleanType_get_volatile(PyGccTree *self, void *closure)
{
    return PyBool_FromLong(TYPE_QUALS(self->t) & TYPE_QUAL_VOLATILE);
}

static PyObject *
gcc_BooleanType_get_volatile_equivalent(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(build_qualified_type(self->t, TYPE_QUAL_VOLATILE));
}

static PyObject *
gcc_BooleanType_get_restrict(PyGccTree *self, void *closure)
{
    return PyBool_FromLong(TYPE_QUALS(self->t) & TYPE_QUAL_RESTRICT);
}

static PyObject *
gcc_BooleanType_get_restrict_equivalent(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(build_qualified_type(self->t, TYPE_QUAL_RESTRICT));
}

static PyGetSetDef gcc_BooleanType_getset_table[] = {
    {"const",
     (getter)gcc_BooleanType_get_const,
     (setter)NULL,
     "Boolean: does this type have the 'const' modifier?",
     NULL},
    {"const_equivalent",
     (getter)gcc_BooleanType_get_const_equivalent,
     (setter)NULL,
     "The gcc.Type for the const version of this type",
     NULL},
    {"volatile",
     (getter)gcc_BooleanType_get_volatile,
     (setter)NULL,
     "Boolean: does this type have the 'volatile' modifier?",
     NULL},
    {"volatile_equivalent",
     (getter)gcc_BooleanType_get_volatile_equivalent,
     (setter)NULL,
     "The gcc.Type for the volatile version of this type",
     NULL},
    {"restrict",
     (getter)gcc_BooleanType_get_restrict,
     (setter)NULL,
     "Boolean: does this type have the 'restrict' modifier?",
     NULL},
    {"restrict_equivalent",
     (getter)gcc_BooleanType_get_restrict_equivalent,
     (setter)NULL,
     "The gcc.Type for the restrict version of this type",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_BooleanTypeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.BooleanType", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_BooleanType_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_IntegerType_get_const(PyGccTree *self, void *closure)
{
    return PyBool_FromLong(TYPE_QUALS(self->t) & TYPE_QUAL_CONST);
}

static PyObject *
gcc_IntegerType_get_const_equivalent(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(build_qualified_type(self->t, TYPE_QUAL_CONST));
}

static PyObject *
gcc_IntegerType_get_volatile(PyGccTree *self, void *closure)
{
    return PyBool_FromLong(TYPE_QUALS(self->t) & TYPE_QUAL_VOLATILE);
}

static PyObject *
gcc_IntegerType_get_volatile_equivalent(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(build_qualified_type(self->t, TYPE_QUAL_VOLATILE));
}

static PyObject *
gcc_IntegerType_get_restrict(PyGccTree *self, void *closure)
{
    return PyBool_FromLong(TYPE_QUALS(self->t) & TYPE_QUAL_RESTRICT);
}

static PyObject *
gcc_IntegerType_get_restrict_equivalent(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(build_qualified_type(self->t, TYPE_QUAL_RESTRICT));
}

static PyObject *
gcc_IntegerType_get_unsigned(PyGccTree *self, void *closure)
{
    return PyBool_FromLong(TYPE_UNSIGNED(self->t));
}

static PyObject *
gcc_IntegerType_get_signed_equivalent(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(c_common_signed_type(self->t));
}

static PyObject *
gcc_IntegerType_get_unsigned_equivalent(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(c_common_unsigned_type(self->t));
}

static PyObject *
gcc_IntegerType_get_max_value(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(TYPE_MAX_VALUE(self->t));
}

static PyObject *
gcc_IntegerType_get_min_value(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(TYPE_MIN_VALUE(self->t));
}

static PyObject *
gcc_IntegerType_get_precision(PyGccTree *self, void *closure)
{
    return gcc_python_int_from_long(TYPE_PRECISION(self->t));
}

static PyGetSetDef gcc_IntegerType_getset_table[] = {
    {"const",
     (getter)gcc_IntegerType_get_const,
     (setter)NULL,
     "Boolean: does this type have the 'const' modifier?",
     NULL},
    {"const_equivalent",
     (getter)gcc_IntegerType_get_const_equivalent,
     (setter)NULL,
     "The gcc.Type for the const version of this type",
     NULL},
    {"volatile",
     (getter)gcc_IntegerType_get_volatile,
     (setter)NULL,
     "Boolean: does this type have the 'volatile' modifier?",
     NULL},
    {"volatile_equivalent",
     (getter)gcc_IntegerType_get_volatile_equivalent,
     (setter)NULL,
     "The gcc.Type for the volatile version of this type",
     NULL},
    {"restrict",
     (getter)gcc_IntegerType_get_restrict,
     (setter)NULL,
     "Boolean: does this type have the 'restrict' modifier?",
     NULL},
    {"restrict_equivalent",
     (getter)gcc_IntegerType_get_restrict_equivalent,
     (setter)NULL,
     "The gcc.Type for the restrict version of this type",
     NULL},
    {"unsigned",
     (getter)gcc_IntegerType_get_unsigned,
     (setter)NULL,
     "Boolean: True for 'unsigned', False for 'signed'",
     NULL},
    {"signed_equivalent",
     (getter)gcc_IntegerType_get_signed_equivalent,
     (setter)NULL,
     "The gcc.IntegerType for the signed version of this type",
     NULL},
    {"unsigned_equivalent",
     (getter)gcc_IntegerType_get_unsigned_equivalent,
     (setter)NULL,
     "The gcc.IntegerType for the unsigned version of this type",
     NULL},
    {"max_value",
     (getter)gcc_IntegerType_get_max_value,
     (setter)NULL,
     "The maximum possible value for this type, as a gcc.IntegerCst",
     NULL},
    {"min_value",
     (getter)gcc_IntegerType_get_min_value,
     (setter)NULL,
     "The minimum possible value for this type, as a gcc.IntegerCst",
     NULL},
    {"precision",
     (getter)gcc_IntegerType_get_precision,
     (setter)NULL,
     "The precision of this type in bits, as an int (e.g. 32)",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_IntegerTypeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.IntegerType", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_IntegerType_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_RealType_get_const(PyGccTree *self, void *closure)
{
    return PyBool_FromLong(TYPE_QUALS(self->t) & TYPE_QUAL_CONST);
}

static PyObject *
gcc_RealType_get_const_equivalent(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(build_qualified_type(self->t, TYPE_QUAL_CONST));
}

static PyObject *
gcc_RealType_get_volatile(PyGccTree *self, void *closure)
{
    return PyBool_FromLong(TYPE_QUALS(self->t) & TYPE_QUAL_VOLATILE);
}

static PyObject *
gcc_RealType_get_volatile_equivalent(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(build_qualified_type(self->t, TYPE_QUAL_VOLATILE));
}

static PyObject *
gcc_RealType_get_restrict(PyGccTree *self, void *closure)
{
    return PyBool_FromLong(TYPE_QUALS(self->t) & TYPE_QUAL_RESTRICT);
}

static PyObject *
gcc_RealType_get_restrict_equivalent(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(build_qualified_type(self->t, TYPE_QUAL_RESTRICT));
}

static PyObject *
gcc_RealType_get_precision(PyGccTree *self, void *closure)
{
    return gcc_python_int_from_long(TYPE_PRECISION(self->t));
}

static PyGetSetDef gcc_RealType_getset_table[] = {
    {"const",
     (getter)gcc_RealType_get_const,
     (setter)NULL,
     "Boolean: does this type have the 'const' modifier?",
     NULL},
    {"const_equivalent",
     (getter)gcc_RealType_get_const_equivalent,
     (setter)NULL,
     "The gcc.Type for the const version of this type",
     NULL},
    {"volatile",
     (getter)gcc_RealType_get_volatile,
     (setter)NULL,
     "Boolean: does this type have the 'volatile' modifier?",
     NULL},
    {"volatile_equivalent",
     (getter)gcc_RealType_get_volatile_equivalent,
     (setter)NULL,
     "The gcc.Type for the volatile version of this type",
     NULL},
    {"restrict",
     (getter)gcc_RealType_get_restrict,
     (setter)NULL,
     "Boolean: does this type have the 'restrict' modifier?",
     NULL},
    {"restrict_equivalent",
     (getter)gcc_RealType_get_restrict_equivalent,
     (setter)NULL,
     "The gcc.Type for the restrict version of this type",
     NULL},
    {"precision",
     (getter)gcc_RealType_get_precision,
     (setter)NULL,
     "The precision of this type in bits, as an int (e.g. 32)",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_RealTypeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.RealType", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_RealType_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_PointerType_get_dereference(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(TREE_TYPE(self->t));
}

static PyGetSetDef gcc_PointerType_getset_table[] = {
    {"dereference",
     (getter)gcc_PointerType_get_dereference,
     (setter)NULL,
     "The gcc.Type that this type points to'",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_PointerTypeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.PointerType", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_PointerType_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ReferenceType_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ReferenceTypeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ReferenceType", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ReferenceType_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_NullptrType_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_NullptrTypeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.NullptrType", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_NullptrType_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_FixedPointType_get_const(PyGccTree *self, void *closure)
{
    return PyBool_FromLong(TYPE_QUALS(self->t) & TYPE_QUAL_CONST);
}

static PyObject *
gcc_FixedPointType_get_const_equivalent(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(build_qualified_type(self->t, TYPE_QUAL_CONST));
}

static PyObject *
gcc_FixedPointType_get_volatile(PyGccTree *self, void *closure)
{
    return PyBool_FromLong(TYPE_QUALS(self->t) & TYPE_QUAL_VOLATILE);
}

static PyObject *
gcc_FixedPointType_get_volatile_equivalent(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(build_qualified_type(self->t, TYPE_QUAL_VOLATILE));
}

static PyObject *
gcc_FixedPointType_get_restrict(PyGccTree *self, void *closure)
{
    return PyBool_FromLong(TYPE_QUALS(self->t) & TYPE_QUAL_RESTRICT);
}

static PyObject *
gcc_FixedPointType_get_restrict_equivalent(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(build_qualified_type(self->t, TYPE_QUAL_RESTRICT));
}

static PyObject *
gcc_FixedPointType_get_precision(PyGccTree *self, void *closure)
{
    return gcc_python_int_from_long(TYPE_PRECISION(self->t));
}

static PyGetSetDef gcc_FixedPointType_getset_table[] = {
    {"const",
     (getter)gcc_FixedPointType_get_const,
     (setter)NULL,
     "Boolean: does this type have the 'const' modifier?",
     NULL},
    {"const_equivalent",
     (getter)gcc_FixedPointType_get_const_equivalent,
     (setter)NULL,
     "The gcc.Type for the const version of this type",
     NULL},
    {"volatile",
     (getter)gcc_FixedPointType_get_volatile,
     (setter)NULL,
     "Boolean: does this type have the 'volatile' modifier?",
     NULL},
    {"volatile_equivalent",
     (getter)gcc_FixedPointType_get_volatile_equivalent,
     (setter)NULL,
     "The gcc.Type for the volatile version of this type",
     NULL},
    {"restrict",
     (getter)gcc_FixedPointType_get_restrict,
     (setter)NULL,
     "Boolean: does this type have the 'restrict' modifier?",
     NULL},
    {"restrict_equivalent",
     (getter)gcc_FixedPointType_get_restrict_equivalent,
     (setter)NULL,
     "The gcc.Type for the restrict version of this type",
     NULL},
    {"precision",
     (getter)gcc_FixedPointType_get_precision,
     (setter)NULL,
     "The precision of this type in bits, as an int (e.g. 32)",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_FixedPointTypeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.FixedPointType", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_FixedPointType_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_ComplexType_get_const(PyGccTree *self, void *closure)
{
    return PyBool_FromLong(TYPE_QUALS(self->t) & TYPE_QUAL_CONST);
}

static PyObject *
gcc_ComplexType_get_const_equivalent(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(build_qualified_type(self->t, TYPE_QUAL_CONST));
}

static PyObject *
gcc_ComplexType_get_volatile(PyGccTree *self, void *closure)
{
    return PyBool_FromLong(TYPE_QUALS(self->t) & TYPE_QUAL_VOLATILE);
}

static PyObject *
gcc_ComplexType_get_volatile_equivalent(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(build_qualified_type(self->t, TYPE_QUAL_VOLATILE));
}

static PyObject *
gcc_ComplexType_get_restrict(PyGccTree *self, void *closure)
{
    return PyBool_FromLong(TYPE_QUALS(self->t) & TYPE_QUAL_RESTRICT);
}

static PyObject *
gcc_ComplexType_get_restrict_equivalent(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(build_qualified_type(self->t, TYPE_QUAL_RESTRICT));
}

static PyGetSetDef gcc_ComplexType_getset_table[] = {
    {"const",
     (getter)gcc_ComplexType_get_const,
     (setter)NULL,
     "Boolean: does this type have the 'const' modifier?",
     NULL},
    {"const_equivalent",
     (getter)gcc_ComplexType_get_const_equivalent,
     (setter)NULL,
     "The gcc.Type for the const version of this type",
     NULL},
    {"volatile",
     (getter)gcc_ComplexType_get_volatile,
     (setter)NULL,
     "Boolean: does this type have the 'volatile' modifier?",
     NULL},
    {"volatile_equivalent",
     (getter)gcc_ComplexType_get_volatile_equivalent,
     (setter)NULL,
     "The gcc.Type for the volatile version of this type",
     NULL},
    {"restrict",
     (getter)gcc_ComplexType_get_restrict,
     (setter)NULL,
     "Boolean: does this type have the 'restrict' modifier?",
     NULL},
    {"restrict_equivalent",
     (getter)gcc_ComplexType_get_restrict_equivalent,
     (setter)NULL,
     "The gcc.Type for the restrict version of this type",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ComplexTypeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ComplexType", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ComplexType_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_VectorType_get_const(PyGccTree *self, void *closure)
{
    return PyBool_FromLong(TYPE_QUALS(self->t) & TYPE_QUAL_CONST);
}

static PyObject *
gcc_VectorType_get_const_equivalent(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(build_qualified_type(self->t, TYPE_QUAL_CONST));
}

static PyObject *
gcc_VectorType_get_volatile(PyGccTree *self, void *closure)
{
    return PyBool_FromLong(TYPE_QUALS(self->t) & TYPE_QUAL_VOLATILE);
}

static PyObject *
gcc_VectorType_get_volatile_equivalent(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(build_qualified_type(self->t, TYPE_QUAL_VOLATILE));
}

static PyObject *
gcc_VectorType_get_restrict(PyGccTree *self, void *closure)
{
    return PyBool_FromLong(TYPE_QUALS(self->t) & TYPE_QUAL_RESTRICT);
}

static PyObject *
gcc_VectorType_get_restrict_equivalent(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(build_qualified_type(self->t, TYPE_QUAL_RESTRICT));
}

static PyObject *
gcc_VectorType_get_dereference(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(TREE_TYPE(self->t));
}

static PyGetSetDef gcc_VectorType_getset_table[] = {
    {"const",
     (getter)gcc_VectorType_get_const,
     (setter)NULL,
     "Boolean: does this type have the 'const' modifier?",
     NULL},
    {"const_equivalent",
     (getter)gcc_VectorType_get_const_equivalent,
     (setter)NULL,
     "The gcc.Type for the const version of this type",
     NULL},
    {"volatile",
     (getter)gcc_VectorType_get_volatile,
     (setter)NULL,
     "Boolean: does this type have the 'volatile' modifier?",
     NULL},
    {"volatile_equivalent",
     (getter)gcc_VectorType_get_volatile_equivalent,
     (setter)NULL,
     "The gcc.Type for the volatile version of this type",
     NULL},
    {"restrict",
     (getter)gcc_VectorType_get_restrict,
     (setter)NULL,
     "Boolean: does this type have the 'restrict' modifier?",
     NULL},
    {"restrict_equivalent",
     (getter)gcc_VectorType_get_restrict_equivalent,
     (setter)NULL,
     "The gcc.Type for the restrict version of this type",
     NULL},
    {"dereference",
     (getter)gcc_VectorType_get_dereference,
     (setter)NULL,
     "The gcc.Type that this type points to'",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_VectorTypeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.VectorType", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_VectorType_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_ArrayType_get_dereference(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(TREE_TYPE(self->t));
}

static PyObject *
gcc_ArrayType_get_range(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(TYPE_DOMAIN(self->t));
}

static PyGetSetDef gcc_ArrayType_getset_table[] = {
    {"dereference",
     (getter)gcc_ArrayType_get_dereference,
     (setter)NULL,
     "The gcc.Type that this type points to'",
     NULL},
    {"range",
     (getter)gcc_ArrayType_get_range,
     (setter)NULL,
     "The gcc.Type that is the range of this array type",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ArrayTypeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ArrayType", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ArrayType_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_RecordType_get_fields(PyGccTree *self, void *closure)
{
    return gcc_tree_list_from_chain(TYPE_FIELDS(self->t));
}

static PyGetSetDef gcc_RecordType_getset_table[] = {
    {"fields",
     (getter)gcc_RecordType_get_fields,
     (setter)NULL,
     "The fields of this type",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_RecordTypeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.RecordType", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_RecordType_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_UnionType_get_fields(PyGccTree *self, void *closure)
{
    return gcc_tree_list_from_chain(TYPE_FIELDS(self->t));
}

static PyGetSetDef gcc_UnionType_getset_table[] = {
    {"fields",
     (getter)gcc_UnionType_get_fields,
     (setter)NULL,
     "The fields of this type",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_UnionTypeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.UnionType", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_UnionType_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_QualUnionType_get_fields(PyGccTree *self, void *closure)
{
    return gcc_tree_list_from_chain(TYPE_FIELDS(self->t));
}

static PyGetSetDef gcc_QualUnionType_getset_table[] = {
    {"fields",
     (getter)gcc_QualUnionType_get_fields,
     (setter)NULL,
     "The fields of this type",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_QualUnionTypeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.QualUnionType", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_QualUnionType_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_VoidType_get_const(PyGccTree *self, void *closure)
{
    return PyBool_FromLong(TYPE_QUALS(self->t) & TYPE_QUAL_CONST);
}

static PyObject *
gcc_VoidType_get_const_equivalent(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(build_qualified_type(self->t, TYPE_QUAL_CONST));
}

static PyObject *
gcc_VoidType_get_volatile(PyGccTree *self, void *closure)
{
    return PyBool_FromLong(TYPE_QUALS(self->t) & TYPE_QUAL_VOLATILE);
}

static PyObject *
gcc_VoidType_get_volatile_equivalent(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(build_qualified_type(self->t, TYPE_QUAL_VOLATILE));
}

static PyObject *
gcc_VoidType_get_restrict(PyGccTree *self, void *closure)
{
    return PyBool_FromLong(TYPE_QUALS(self->t) & TYPE_QUAL_RESTRICT);
}

static PyObject *
gcc_VoidType_get_restrict_equivalent(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(build_qualified_type(self->t, TYPE_QUAL_RESTRICT));
}

static PyGetSetDef gcc_VoidType_getset_table[] = {
    {"const",
     (getter)gcc_VoidType_get_const,
     (setter)NULL,
     "Boolean: does this type have the 'const' modifier?",
     NULL},
    {"const_equivalent",
     (getter)gcc_VoidType_get_const_equivalent,
     (setter)NULL,
     "The gcc.Type for the const version of this type",
     NULL},
    {"volatile",
     (getter)gcc_VoidType_get_volatile,
     (setter)NULL,
     "Boolean: does this type have the 'volatile' modifier?",
     NULL},
    {"volatile_equivalent",
     (getter)gcc_VoidType_get_volatile_equivalent,
     (setter)NULL,
     "The gcc.Type for the volatile version of this type",
     NULL},
    {"restrict",
     (getter)gcc_VoidType_get_restrict,
     (setter)NULL,
     "Boolean: does this type have the 'restrict' modifier?",
     NULL},
    {"restrict_equivalent",
     (getter)gcc_VoidType_get_restrict_equivalent,
     (setter)NULL,
     "The gcc.Type for the restrict version of this type",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_VoidTypeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.VoidType", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_VoidType_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_FunctionType_getset_table[] = {
    {"argument_types",
     (getter)gcc_FunctionType_get_argument_types,
     (setter)NULL,
     "A tuple of gcc.Type instances, representing the argument types of this function type",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_FunctionTypeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.FunctionType", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_FunctionType_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_MethodType_getset_table[] = {
    {"argument_types",
     (getter)gcc_MethodType_get_argument_types,
     (setter)NULL,
     "A tuple of gcc.Type instances, representing the argument types of this method type",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_MethodTypeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.MethodType", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_MethodType_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_LangType_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_LangTypeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.LangType", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_LangType_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyNumberMethods gcc_IntegerConstant_number_methods = {
    .nb_add = NULL,
    .nb_subtract = NULL,
    .nb_multiply = NULL,
#if PY_MAJOR_VERSION < 3
    .nb_divide = NULL,
#endif
    .nb_remainder = NULL,
    .nb_divmod = NULL,
    .nb_power = NULL,
    .nb_negative = (unaryfunc)NULL,
    .nb_positive = (unaryfunc)NULL,
    .nb_absolute = (unaryfunc)NULL,
#if PY_MAJOR_VERSION >= 3
    .nb_bool = NULL,
#else
    .nb_nonzero = NULL,
#endif
    .nb_invert = (unaryfunc)NULL,
    .nb_lshift = NULL,
    .nb_rshift = NULL,
    .nb_and = NULL,
    .nb_xor = NULL,
    .nb_or = NULL,
#if PY_MAJOR_VERSION < 3
    .nb_coerce = NULL,
#endif
    .nb_int = (unaryfunc)gcc_IntegerConstant_get_constant,
#if PY_MAJOR_VERSION >= 3
    .nb_reserved = NULL,
#else
    .nb_long = (unaryfunc)NULL,
#endif
    .nb_float = (unaryfunc)NULL,
#if PY_MAJOR_VERSION < 3
    .nb_oct = (unaryfunc)NULL,
    .nb_hex = (unaryfunc)NULL,
#endif
    .nb_inplace_add = NULL,
    .nb_inplace_subtract = NULL,
    .nb_inplace_multiply = NULL,
#if PY_MAJOR_VERSION < 3
    .nb_inplace_divide = NULL,
#endif
    .nb_inplace_remainder = NULL,
    .nb_inplace_power = NULL,
    .nb_inplace_lshift = NULL,
    .nb_inplace_rshift = NULL,
    .nb_inplace_and = NULL,
    .nb_inplace_xor = NULL,
    .nb_inplace_or = NULL,
    .nb_floor_divide = NULL,
    .nb_true_divide = NULL,
    .nb_inplace_floor_divide = NULL,
    .nb_inplace_true_divide = NULL,
    .nb_index = (unaryfunc)NULL,
};
static PyGetSetDef gcc_IntegerCst_getset_table[] = {
    {"constant",
     (getter)gcc_IntegerConstant_get_constant,
     (setter)NULL,
     "The actual value of this constant, as an int/long",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_IntegerCstType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.IntegerCst", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = (reprfunc)gcc_IntegerConstant_repr,
            .tp_as_number = &gcc_IntegerConstant_number_methods,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_IntegerCst_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ConstantType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_RealCst_getset_table[] = {
    {"constant",
     (getter)gcc_RealCst_get_constant,
     (setter)NULL,
     "The actual value of this constant, as a float",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_RealCstType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.RealCst", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = (reprfunc)gcc_RealCst_repr,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_RealCst_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ConstantType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_FixedCst_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_FixedCstType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.FixedCst", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_FixedCst_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ConstantType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ComplexCst_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ComplexCstType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ComplexCst", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ComplexCst_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ConstantType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_VectorCst_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_VectorCstType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.VectorCst", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_VectorCst_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ConstantType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_StringCst_get_constant(PyGccTree *self, void *closure)
{
    return gcc_python_string_from_string(TREE_STRING_POINTER(self->t));
}

static PyGetSetDef gcc_StringCst_getset_table[] = {
    {"constant",
     (getter)gcc_StringCst_get_constant,
     (setter)NULL,
     "The actual value of this constant, as a str",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_StringCstType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.StringCst", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = (reprfunc)gcc_StringConstant_repr,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_StringCst_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ConstantType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_FunctionDecl_get_function(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_function(DECL_STRUCT_FUNCTION(self->t));
}

static PyObject *
gcc_FunctionDecl_get_arguments(PyGccTree *self, void *closure)
{
    return gcc_tree_list_from_chain(DECL_ARGUMENTS(self->t));
}

static PyObject *
gcc_FunctionDecl_get_result(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(DECL_RESULT_FLD(self->t));
}

static PyObject *
gcc_FunctionDecl_get_callgraph_node(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_cgraph_node(cgraph_get_node(self->t));
}

static PyObject *
gcc_FunctionDecl_get_is_public(PyGccTree *self, void *closure)
{
    return PyBool_FromLong(TREE_PUBLIC(self->t));
}

static PyObject *
gcc_FunctionDecl_get_is_private(PyGccTree *self, void *closure)
{
    return PyBool_FromLong(TREE_PRIVATE(self->t));
}

static PyObject *
gcc_FunctionDecl_get_is_protected(PyGccTree *self, void *closure)
{
    return PyBool_FromLong(TREE_PROTECTED(self->t));
}

static PyObject *
gcc_FunctionDecl_get_is_static(PyGccTree *self, void *closure)
{
    return PyBool_FromLong(TREE_STATIC(self->t));
}

static PyGetSetDef gcc_FunctionDecl_getset_table[] = {
    {"fullname",
     (getter)gcc_FunctionDecl_get_fullname,
     (setter)NULL,
     "C++ only: the full name of this function declaration",
     NULL},
    {"function",
     (getter)gcc_FunctionDecl_get_function,
     (setter)NULL,
     "The gcc.Function (or None) for this declaration",
     NULL},
    {"arguments",
     (getter)gcc_FunctionDecl_get_arguments,
     (setter)NULL,
     "List of gcc.ParmDecl",
     NULL},
    {"result",
     (getter)gcc_FunctionDecl_get_result,
     (setter)NULL,
     "The gcc.ResultDecl for the return value",
     NULL},
    {"callgraph_node",
     (getter)gcc_FunctionDecl_get_callgraph_node,
     (setter)NULL,
     "The gcc.CallgraphNode for this function declaration, or None",
     NULL},
    {"is_public",
     (getter)gcc_FunctionDecl_get_is_public,
     (setter)NULL,
     "NULL",
     NULL},
    {"is_private",
     (getter)gcc_FunctionDecl_get_is_private,
     (setter)NULL,
     "NULL",
     NULL},
    {"is_protected",
     (getter)gcc_FunctionDecl_get_is_protected,
     (setter)NULL,
     "NULL",
     NULL},
    {"is_static",
     (getter)gcc_FunctionDecl_get_is_static,
     (setter)NULL,
     "NULL",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_FunctionDeclType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.FunctionDecl", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_FunctionDecl_getset_table,
            .tp_base = (PyTypeObject*)&gcc_DeclarationType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_LabelDecl_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_LabelDeclType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.LabelDecl", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_LabelDecl_getset_table,
            .tp_base = (PyTypeObject*)&gcc_DeclarationType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_FieldDecl_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_FieldDeclType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.FieldDecl", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_FieldDecl_getset_table,
            .tp_base = (PyTypeObject*)&gcc_DeclarationType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_VarDecl_get_initial(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(DECL_INITIAL(self->t));
}

static PyObject *
gcc_VarDecl_get_static(PyGccTree *self, void *closure)
{
    return PyBool_FromLong(TREE_STATIC(self->t));
}

static PyGetSetDef gcc_VarDecl_getset_table[] = {
    {"initial",
     (getter)gcc_VarDecl_get_initial,
     (setter)NULL,
     "The initial value for this variable as a gcc.Constructor, or None",
     NULL},
    {"static",
     (getter)gcc_VarDecl_get_static,
     (setter)NULL,
     "Boolean: is this variable to be allocated with static storage",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_VarDeclType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.VarDecl", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_VarDecl_getset_table,
            .tp_base = (PyTypeObject*)&gcc_DeclarationType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ConstDecl_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ConstDeclType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ConstDecl", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ConstDecl_getset_table,
            .tp_base = (PyTypeObject*)&gcc_DeclarationType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ParmDecl_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ParmDeclType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ParmDecl", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ParmDecl_getset_table,
            .tp_base = (PyTypeObject*)&gcc_DeclarationType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TypeDecl_getset_table[] = {
    {"pointer",
     (getter)gcc_TypeDecl_get_pointer,
     (setter)NULL,
     "The gcc.PointerType representing '(this_type *)'",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TypeDeclType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TypeDecl", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TypeDecl_getset_table,
            .tp_base = (PyTypeObject*)&gcc_DeclarationType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ResultDecl_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ResultDeclType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ResultDecl", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ResultDecl_getset_table,
            .tp_base = (PyTypeObject*)&gcc_DeclarationType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_DebugExprDecl_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_DebugExprDeclType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.DebugExprDecl", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_DebugExprDecl_getset_table,
            .tp_base = (PyTypeObject*)&gcc_DeclarationType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_NamespaceDecl_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_NamespaceDeclType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.NamespaceDecl", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_NamespaceDecl_getset_table,
            .tp_base = (PyTypeObject*)&gcc_DeclarationType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ImportedDecl_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ImportedDeclType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ImportedDecl", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ImportedDecl_getset_table,
            .tp_base = (PyTypeObject*)&gcc_DeclarationType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_TranslationUnitDecl_get_block(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(DECL_INITIAL(self->t));
}

static PyObject *
gcc_TranslationUnitDecl_get_language(PyGccTree *self, void *closure)
{
    return gcc_python_string_from_string(TRANSLATION_UNIT_LANGUAGE(self->t));
}

static PyGetSetDef gcc_TranslationUnitDecl_getset_table[] = {
    {"block",
     (getter)gcc_TranslationUnitDecl_get_block,
     (setter)NULL,
     "The gcc.Block for this namespace",
     NULL},
    {"language",
     (getter)gcc_TranslationUnitDecl_get_language,
     (setter)NULL,
     "The source language of this translation unit, as a string",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TranslationUnitDeclType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TranslationUnitDecl", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TranslationUnitDecl_getset_table,
            .tp_base = (PyTypeObject*)&gcc_DeclarationType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_ComponentRef_get_target(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(TREE_OPERAND(self->t, 0));
}

static PyObject *
gcc_ComponentRef_get_field(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(TREE_OPERAND(self->t, 1));
}

static PyGetSetDef gcc_ComponentRef_getset_table[] = {
    {"target",
     (getter)gcc_ComponentRef_get_target,
     (setter)NULL,
     "The gcc.Tree that for the container of the field'",
     NULL},
    {"field",
     (getter)gcc_ComponentRef_get_field,
     (setter)NULL,
     "The gcc.FieldDecl for the field within the target'",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ComponentRefType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ComponentRef", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ComponentRef_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ReferenceType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_BitFieldRef_get_operand(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(TREE_OPERAND(self->t, 0));
}

static PyObject *
gcc_BitFieldRef_get_num_bits(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(TREE_OPERAND(self->t, 1));
}

static PyObject *
gcc_BitFieldRef_get_position(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(TREE_OPERAND(self->t, 2));
}

static PyGetSetDef gcc_BitFieldRef_getset_table[] = {
    {"operand",
     (getter)gcc_BitFieldRef_get_operand,
     (setter)NULL,
     "The gcc.Tree for the structure or union expression",
     NULL},
    {"num_bits",
     (getter)gcc_BitFieldRef_get_num_bits,
     (setter)NULL,
     "The number of bits being referenced, as a gcc.IntegerCst",
     NULL},
    {"position",
     (getter)gcc_BitFieldRef_get_position,
     (setter)NULL,
     "The position of the first referenced bit, as a gcc.IntegerCst",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_BitFieldRefType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.BitFieldRef", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_BitFieldRef_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ReferenceType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_RealpartExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_RealpartExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.RealpartExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_RealpartExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ReferenceType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ImagpartExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ImagpartExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ImagpartExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ImagpartExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ReferenceType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_ArrayRef_get_array(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(TREE_OPERAND(self->t, 0));
}

static PyObject *
gcc_ArrayRef_get_index(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(TREE_OPERAND(self->t, 1));
}

static PyGetSetDef gcc_ArrayRef_getset_table[] = {
    {"array",
     (getter)gcc_ArrayRef_get_array,
     (setter)NULL,
     "The gcc.Tree for the array being referenced'",
     NULL},
    {"index",
     (getter)gcc_ArrayRef_get_index,
     (setter)NULL,
     "The gcc.Tree for index being referenced'",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ArrayRefType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ArrayRef", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ArrayRef_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ReferenceType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ArrayRangeRef_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ArrayRangeRefType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ArrayRangeRef", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ArrayRangeRef_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ReferenceType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_IndirectRef_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_IndirectRefType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.IndirectRef", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_IndirectRef_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ReferenceType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ObjTypeRef_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ObjTypeRefType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ObjTypeRef", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ObjTypeRef_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_Constructor_getset_table[] = {
    {"elements",
     (getter)gcc_Constructor_get_elements,
     (setter)NULL,
     "The elements of this constructor, as a list of (index, gcc.Tree) pairs",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ConstructorType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.Constructor", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_Constructor_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_CompoundExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_CompoundExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.CompoundExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_CompoundExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ModifyExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ModifyExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ModifyExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ModifyExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_InitExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_InitExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.InitExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_InitExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TargetExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TargetExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TargetExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TargetExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_CondExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_CondExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.CondExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_CondExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_VecCondExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_VecCondExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.VecCondExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_VecCondExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_VecPermExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_VecPermExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.VecPermExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_VecPermExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_BindExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_BindExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.BindExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_BindExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_CallExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_CallExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.CallExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_CallExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_VlExpType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_WithCleanupExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_WithCleanupExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.WithCleanupExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_WithCleanupExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_CleanupPointExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_CleanupPointExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.CleanupPointExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_CleanupPointExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_PlaceholderExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_PlaceholderExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.PlaceholderExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_PlaceholderExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_PlusExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_PlusExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.PlusExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_PlusExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_MinusExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_MinusExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.MinusExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_MinusExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_MultExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_MultExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.MultExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_MultExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_PointerPlusExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_PointerPlusExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.PointerPlusExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_PointerPlusExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TruncDivExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TruncDivExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TruncDivExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TruncDivExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_CeilDivExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_CeilDivExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.CeilDivExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_CeilDivExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_FloorDivExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_FloorDivExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.FloorDivExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_FloorDivExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_RoundDivExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_RoundDivExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.RoundDivExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_RoundDivExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TruncModExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TruncModExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TruncModExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TruncModExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_CeilModExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_CeilModExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.CeilModExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_CeilModExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_FloorModExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_FloorModExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.FloorModExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_FloorModExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_RoundModExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_RoundModExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.RoundModExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_RoundModExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_RdivExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_RdivExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.RdivExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_RdivExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ExactDivExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ExactDivExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ExactDivExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ExactDivExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_FixTruncExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_FixTruncExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.FixTruncExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_FixTruncExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_UnaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_FloatExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_FloatExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.FloatExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_FloatExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_UnaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_NegateExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_NegateExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.NegateExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_NegateExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_UnaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_MinExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_MinExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.MinExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_MinExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_MaxExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_MaxExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.MaxExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_MaxExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_AbsExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_AbsExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.AbsExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_AbsExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_UnaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_LshiftExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_LshiftExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.LshiftExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_LshiftExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_RshiftExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_RshiftExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.RshiftExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_RshiftExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_LrotateExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_LrotateExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.LrotateExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_LrotateExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_RrotateExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_RrotateExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.RrotateExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_RrotateExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_BitIorExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_BitIorExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.BitIorExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_BitIorExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_BitXorExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_BitXorExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.BitXorExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_BitXorExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_BitAndExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_BitAndExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.BitAndExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_BitAndExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_BitNotExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_BitNotExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.BitNotExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_BitNotExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_UnaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TruthAndifExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TruthAndifExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TruthAndifExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TruthAndifExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TruthOrifExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TruthOrifExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TruthOrifExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TruthOrifExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TruthAndExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TruthAndExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TruthAndExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TruthAndExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TruthOrExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TruthOrExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TruthOrExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TruthOrExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TruthXorExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TruthXorExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TruthXorExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TruthXorExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TruthNotExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TruthNotExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TruthNotExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TruthNotExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_LtExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_LtExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.LtExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_LtExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ComparisonType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_LeExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_LeExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.LeExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_LeExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ComparisonType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_GtExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_GtExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.GtExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_GtExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ComparisonType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_GeExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_GeExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.GeExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_GeExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ComparisonType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_EqExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_EqExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.EqExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_EqExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ComparisonType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_NeExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_NeExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.NeExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_NeExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ComparisonType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_UnorderedExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_UnorderedExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.UnorderedExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_UnorderedExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ComparisonType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_OrderedExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_OrderedExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.OrderedExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_OrderedExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ComparisonType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_UnltExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_UnltExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.UnltExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_UnltExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ComparisonType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_UnleExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_UnleExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.UnleExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_UnleExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ComparisonType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_UngtExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_UngtExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.UngtExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_UngtExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ComparisonType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_UngeExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_UngeExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.UngeExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_UngeExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ComparisonType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_UneqExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_UneqExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.UneqExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_UneqExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ComparisonType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_LtgtExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_LtgtExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.LtgtExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_LtgtExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ComparisonType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_RangeExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_RangeExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.RangeExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_RangeExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ParenExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ParenExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ParenExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ParenExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_UnaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ConvertExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ConvertExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ConvertExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ConvertExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_UnaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_AddrSpaceConvertExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_AddrSpaceConvertExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.AddrSpaceConvertExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_AddrSpaceConvertExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_UnaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_FixedConvertExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_FixedConvertExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.FixedConvertExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_FixedConvertExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_UnaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_NopExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_NopExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.NopExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_NopExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_UnaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_NonLvalueExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_NonLvalueExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.NonLvalueExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_NonLvalueExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_UnaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ViewConvertExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ViewConvertExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ViewConvertExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ViewConvertExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ReferenceType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_CompoundLiteralExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_CompoundLiteralExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.CompoundLiteralExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_CompoundLiteralExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_SaveExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_SaveExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.SaveExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_SaveExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_AddrExpr_get_operand(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(TREE_OPERAND (self->t, 0));
}

static PyGetSetDef gcc_AddrExpr_getset_table[] = {
    {"operand",
     (getter)gcc_AddrExpr_get_operand,
     (setter)NULL,
     "The operand of this expression, as a gcc.Tree",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_AddrExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.AddrExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_AddrExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_FdescExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_FdescExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.FdescExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_FdescExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ComplexExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ComplexExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ComplexExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ComplexExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ConjExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ConjExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ConjExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ConjExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_UnaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_PredecrementExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_PredecrementExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.PredecrementExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_PredecrementExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_PreincrementExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_PreincrementExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.PreincrementExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_PreincrementExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_PostdecrementExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_PostdecrementExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.PostdecrementExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_PostdecrementExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_PostincrementExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_PostincrementExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.PostincrementExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_PostincrementExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_VaArgExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_VaArgExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.VaArgExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_VaArgExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TryCatchExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TryCatchExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TryCatchExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TryCatchExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TryFinally_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TryFinallyType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TryFinally", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TryFinally_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_DeclExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_DeclExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.DeclExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_DeclExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_LabelExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_LabelExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.LabelExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_LabelExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_GotoExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_GotoExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.GotoExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_GotoExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ReturnExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ReturnExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ReturnExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ReturnExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ExitExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ExitExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ExitExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ExitExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_LoopExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_LoopExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.LoopExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_LoopExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_SwitchExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_SwitchExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.SwitchExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_SwitchExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_CaseLabelExpr_get_low(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(CASE_LOW(self->t));
}

static PyObject *
gcc_CaseLabelExpr_get_high(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(CASE_HIGH(self->t));
}

static PyObject *
gcc_CaseLabelExpr_get_target(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(CASE_LABEL(self->t));
}

static PyGetSetDef gcc_CaseLabelExpr_getset_table[] = {
    {"low",
     (getter)gcc_CaseLabelExpr_get_low,
     (setter)NULL,
     "The low value of the case label, as a gcc.Tree (or None for the default)",
     NULL},
    {"high",
     (getter)gcc_CaseLabelExpr_get_high,
     (setter)NULL,
     "The high value of the case label, if any, as a gcc.Tree (None for the default and for single-valued case labels)",
     NULL},
    {"target",
     (getter)gcc_CaseLabelExpr_get_target,
     (setter)NULL,
     "The target of the case label, as a gcc.LabelDecl",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_CaseLabelExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.CaseLabelExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_CaseLabelExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_AsmExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_AsmExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.AsmExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_AsmExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_SsaName_get_var(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(SSA_NAME_VAR(self->t));
}

static PyObject *
gcc_SsaName_get_def_stmt(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_gimple(SSA_NAME_DEF_STMT(self->t));
}

static PyObject *
gcc_SsaName_get_version(PyGccTree *self, void *closure)
{
    return gcc_python_int_from_long(SSA_NAME_VERSION(self->t));
}

static PyGetSetDef gcc_SsaName_getset_table[] = {
    {"var",
     (getter)gcc_SsaName_get_var,
     (setter)NULL,
     "The variable being referenced'",
     NULL},
    {"def_stmt",
     (getter)gcc_SsaName_get_def_stmt,
     (setter)NULL,
     "The gcc.Gimple statement which defines this SSA name'",
     NULL},
    {"version",
     (getter)gcc_SsaName_get_version,
     (setter)NULL,
     "The SSA version number of this SSA name'",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_SsaNameType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.SsaName", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_SsaName_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_CatchExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_CatchExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.CatchExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_CatchExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_EhFilterExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_EhFilterExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.EhFilterExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_EhFilterExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ScevKnown_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ScevKnownType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ScevKnown", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ScevKnown_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ScevNotKnown_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ScevNotKnownType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ScevNotKnown", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ScevNotKnown_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_PolynomialChrec_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_PolynomialChrecType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.PolynomialChrec", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_PolynomialChrec_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_StatementList_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_StatementListType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.StatementList", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_StatementList_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_AssertExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_AssertExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.AssertExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_AssertExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TreeBinfo_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TreeBinfoType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TreeBinfo", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TreeBinfo_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_WithSizeExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_WithSizeExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.WithSizeExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_WithSizeExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_RealignLoad_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_RealignLoadType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.RealignLoad", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_RealignLoad_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TargetMemRef_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TargetMemRefType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TargetMemRef", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TargetMemRef_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ReferenceType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyObject *
gcc_MemRef_get_operand(PyGccTree *self, void *closure)
{
    return gcc_python_make_wrapper_tree(TREE_OPERAND(self->t, 0));
}

static PyGetSetDef gcc_MemRef_getset_table[] = {
    {"operand",
     (getter)gcc_MemRef_get_operand,
     (setter)NULL,
     "The gcc.Tree that for the pointer expression'",
     NULL},
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_MemRefType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.MemRef", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_MemRef_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ReferenceType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_OmpParallel_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_OmpParallelType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.OmpParallel", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_OmpParallel_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_OmpTask_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_OmpTaskType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.OmpTask", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_OmpTask_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_OmpFor_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_OmpForType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.OmpFor", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_OmpFor_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_OmpSections_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_OmpSectionsType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.OmpSections", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_OmpSections_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_OmpSingle_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_OmpSingleType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.OmpSingle", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_OmpSingle_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_OmpSection_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_OmpSectionType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.OmpSection", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_OmpSection_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_OmpMaster_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_OmpMasterType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.OmpMaster", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_OmpMaster_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_OmpOrdered_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_OmpOrderedType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.OmpOrdered", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_OmpOrdered_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_OmpCritical_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_OmpCriticalType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.OmpCritical", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_OmpCritical_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_OmpAtomic_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_OmpAtomicType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.OmpAtomic", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_OmpAtomic_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_OmpAtomicRead_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_OmpAtomicReadType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.OmpAtomicRead", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_OmpAtomicRead_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_OmpAtomicCaptureOld_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_OmpAtomicCaptureOldType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.OmpAtomicCaptureOld", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_OmpAtomicCaptureOld_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_OmpAtomicCaptureNew_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_OmpAtomicCaptureNewType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.OmpAtomicCaptureNew", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_OmpAtomicCaptureNew_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_OmpClause_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_OmpClauseType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.OmpClause", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_OmpClause_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TransactionExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TransactionExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TransactionExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TransactionExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ReducMaxExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ReducMaxExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ReducMaxExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ReducMaxExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_UnaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ReducMinExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ReducMinExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ReducMinExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ReducMinExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_UnaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ReducPlusExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ReducPlusExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ReducPlusExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ReducPlusExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_UnaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_DotProdExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_DotProdExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.DotProdExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_DotProdExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_WidenSumExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_WidenSumExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.WidenSumExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_WidenSumExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_WidenMultExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_WidenMultExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.WidenMultExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_WidenMultExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_WidenMultPlusExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_WidenMultPlusExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.WidenMultPlusExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_WidenMultPlusExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_WidenMultMinusExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_WidenMultMinusExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.WidenMultMinusExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_WidenMultMinusExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_WidenLshiftExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_WidenLshiftExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.WidenLshiftExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_WidenLshiftExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_FmaExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_FmaExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.FmaExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_FmaExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_VecLshiftExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_VecLshiftExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.VecLshiftExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_VecLshiftExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_VecRshiftExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_VecRshiftExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.VecRshiftExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_VecRshiftExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_WidenMultHiExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_WidenMultHiExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.WidenMultHiExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_WidenMultHiExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_WidenMultLoExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_WidenMultLoExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.WidenMultLoExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_WidenMultLoExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_VecUnpackHiExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_VecUnpackHiExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.VecUnpackHiExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_VecUnpackHiExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_UnaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_VecUnpackLoExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_VecUnpackLoExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.VecUnpackLoExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_VecUnpackLoExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_UnaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_VecUnpackFloatHiExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_VecUnpackFloatHiExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.VecUnpackFloatHiExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_VecUnpackFloatHiExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_UnaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_VecUnpackFloatLoExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_VecUnpackFloatLoExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.VecUnpackFloatLoExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_VecUnpackFloatLoExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_UnaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_VecPackTruncExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_VecPackTruncExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.VecPackTruncExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_VecPackTruncExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_VecPackSatExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_VecPackSatExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.VecPackSatExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_VecPackSatExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_VecPackFixTruncExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_VecPackFixTruncExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.VecPackFixTruncExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_VecPackFixTruncExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_WidenLshiftHiExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_WidenLshiftHiExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.WidenLshiftHiExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_WidenLshiftHiExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_WidenLshiftLoExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_WidenLshiftLoExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.WidenLshiftLoExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_WidenLshiftLoExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_PredictExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_PredictExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.PredictExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_PredictExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_OptimizationNode_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_OptimizationNodeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.OptimizationNode", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_OptimizationNode_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TargetOptionNode_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TargetOptionNodeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TargetOptionNode", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TargetOptionNode_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_CMaybeConstExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_CMaybeConstExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.CMaybeConstExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_CMaybeConstExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ExcessPrecisionExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ExcessPrecisionExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ExcessPrecisionExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ExcessPrecisionExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_UserdefLiteral_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_UserdefLiteralType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.UserdefLiteral", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_UserdefLiteral_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_UnconstrainedArrayType_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_UnconstrainedArrayTypeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.UnconstrainedArrayType", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_UnconstrainedArrayType_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_UnconstrainedArrayRef_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_UnconstrainedArrayRefType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.UnconstrainedArrayRef", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_UnconstrainedArrayRef_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ReferenceType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_NullExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_NullExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.NullExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_NullExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_PlusNomodExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_PlusNomodExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.PlusNomodExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_PlusNomodExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_MinusNomodExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_MinusNomodExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.MinusNomodExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_MinusNomodExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_AttrAddrExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_AttrAddrExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.AttrAddrExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_AttrAddrExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ReferenceType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_StmtStmt_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_StmtStmtType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.StmtStmt", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_StmtStmt_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_LoopStmt_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_LoopStmtType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.LoopStmt", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_LoopStmt_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ExitStmt_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ExitStmtType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ExitStmt", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ExitStmt_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_OffsetRef_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_OffsetRefType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.OffsetRef", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_OffsetRef_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ReferenceType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_PtrmemCst_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_PtrmemCstType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.PtrmemCst", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_PtrmemCst_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ConstantType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_NwExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_NwExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.NwExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_NwExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_VecNwExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_VecNwExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.VecNwExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_VecNwExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_DlExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_DlExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.DlExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_DlExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_VecDlExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_VecDlExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.VecDlExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_VecDlExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ScopeRef_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ScopeRefType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ScopeRef", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ScopeRef_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ReferenceType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_MemberRef_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_MemberRefType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.MemberRef", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_MemberRef_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ReferenceType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TypeExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TypeExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TypeExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TypeExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_AggrInitExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_AggrInitExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.AggrInitExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_AggrInitExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_VlExpType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_VecInitExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_VecInitExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.VecInitExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_VecInitExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ThrowExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ThrowExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ThrowExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ThrowExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_EmptyClassExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_EmptyClassExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.EmptyClassExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_EmptyClassExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_Baselink_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_BaselinkType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.Baselink", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_Baselink_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TemplateDecl_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TemplateDeclType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TemplateDecl", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TemplateDecl_getset_table,
            .tp_base = (PyTypeObject*)&gcc_DeclarationType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TemplateParmIndex_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TemplateParmIndexType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TemplateParmIndex", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TemplateParmIndex_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TemplateTemplateParm_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TemplateTemplateParmType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TemplateTemplateParm", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TemplateTemplateParm_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TemplateTypeParm_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TemplateTypeParmType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TemplateTypeParm", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TemplateTypeParm_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TypenameType_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TypenameTypeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TypenameType", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TypenameType_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TypeofType_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TypeofTypeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TypeofType", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TypeofType_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_BoundTemplateTemplateParm_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_BoundTemplateTemplateParmType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.BoundTemplateTemplateParm", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_BoundTemplateTemplateParm_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_UnboundClassTemplate_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_UnboundClassTemplateType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.UnboundClassTemplate", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_UnboundClassTemplate_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_UsingDecl_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_UsingDeclType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.UsingDecl", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_UsingDecl_getset_table,
            .tp_base = (PyTypeObject*)&gcc_DeclarationType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_UsingStmt_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_UsingStmtType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.UsingStmt", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_UsingStmt_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_DefaultArg_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_DefaultArgType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.DefaultArg", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_DefaultArg_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_DeferredNoexcept_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_DeferredNoexceptType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.DeferredNoexcept", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_DeferredNoexcept_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TemplateIdExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TemplateIdExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TemplateIdExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TemplateIdExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_Overload_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_OverloadType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.Overload", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_Overload_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_PseudoDtorExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_PseudoDtorExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.PseudoDtorExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_PseudoDtorExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ModopExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ModopExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ModopExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ModopExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_CastExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_CastExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.CastExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_CastExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_UnaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ReinterpretCastExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ReinterpretCastExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ReinterpretCastExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ReinterpretCastExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_UnaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ConstCastExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ConstCastExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ConstCastExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ConstCastExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_UnaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_StaticCastExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_StaticCastExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.StaticCastExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_StaticCastExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_UnaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_DynamicCastExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_DynamicCastExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.DynamicCastExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_DynamicCastExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_UnaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ImplicitConvExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ImplicitConvExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ImplicitConvExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ImplicitConvExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_UnaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_DotstarExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_DotstarExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.DotstarExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_DotstarExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TypeidExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TypeidExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TypeidExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TypeidExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_NoexceptExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_NoexceptExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.NoexceptExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_NoexceptExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_UnaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_NonDependentExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_NonDependentExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.NonDependentExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_NonDependentExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_CtorInitializer_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_CtorInitializerType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.CtorInitializer", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_CtorInitializer_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TryBlock_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TryBlockType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TryBlock", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TryBlock_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_EhSpecBlock_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_EhSpecBlockType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.EhSpecBlock", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_EhSpecBlock_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_Handler_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_HandlerType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.Handler", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_Handler_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_MustNotThrowExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_MustNotThrowExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.MustNotThrowExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_MustNotThrowExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_CleanupStmt_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_CleanupStmtType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.CleanupStmt", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_CleanupStmt_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_IfStmt_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_IfStmtType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.IfStmt", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_IfStmt_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ForStmt_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ForStmtType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ForStmt", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ForStmt_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_RangeForStmt_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_RangeForStmtType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.RangeForStmt", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_RangeForStmt_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_WhileStmt_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_WhileStmtType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.WhileStmt", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_WhileStmt_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_DoStmt_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_DoStmtType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.DoStmt", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_DoStmt_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_BreakStmt_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_BreakStmtType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.BreakStmt", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_BreakStmt_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ContinueStmt_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ContinueStmtType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ContinueStmt", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ContinueStmt_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_SwitchStmt_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_SwitchStmtType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.SwitchStmt", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_SwitchStmt_getset_table,
            .tp_base = (PyTypeObject*)&gcc_StatementType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ExprStmt_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ExprStmtType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ExprStmt", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ExprStmt_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TagDefn_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TagDefnType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TagDefn", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TagDefn_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_OffsetofExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_OffsetofExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.OffsetofExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_OffsetofExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_SizeofExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_SizeofExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.SizeofExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_SizeofExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ArrowExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ArrowExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ArrowExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ArrowExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_AlignofExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_AlignofExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.AlignofExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_AlignofExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_AtEncodeExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_AtEncodeExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.AtEncodeExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_AtEncodeExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_StmtExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_StmtExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.StmtExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_StmtExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_UnaryPlusExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_UnaryPlusExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.UnaryPlusExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_UnaryPlusExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_UnaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_StaticAssert_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_StaticAssertType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.StaticAssert", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_StaticAssert_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TypeArgumentPack_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TypeArgumentPackType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TypeArgumentPack", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TypeArgumentPack_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_NontypeArgumentPack_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_NontypeArgumentPackType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.NontypeArgumentPack", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_NontypeArgumentPack_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TypePackExpansion_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TypePackExpansionType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TypePackExpansion", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TypePackExpansion_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ExprPackExpansion_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ExprPackExpansionType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ExprPackExpansion", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ExprPackExpansion_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ArgumentPackSelect_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ArgumentPackSelectType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ArgumentPackSelect", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ArgumentPackSelect_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TraitExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TraitExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TraitExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TraitExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_LambdaExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_LambdaExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.LambdaExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_LambdaExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_DecltypeType_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_DecltypeTypeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.DecltypeType", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_DecltypeType_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_UnderlyingType_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_UnderlyingTypeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.UnderlyingType", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_UnderlyingType_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_Bases_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_BasesType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.Bases", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_Bases_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_TemplateInfo_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_TemplateInfoType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.TemplateInfo", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_TemplateInfo_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TreeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_UrshiftExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_UrshiftExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.UrshiftExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_UrshiftExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_CompareExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_CompareExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.CompareExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_CompareExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_CompareLExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_CompareLExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.CompareLExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_CompareLExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_CompareGExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_CompareGExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.CompareGExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_CompareGExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_BinaryType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ClassInterfaceType_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ClassInterfaceTypeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ClassInterfaceType", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ClassInterfaceType_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ClassImplementationType_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ClassImplementationTypeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ClassImplementationType", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ClassImplementationType_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_CategoryInterfaceType_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_CategoryInterfaceTypeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.CategoryInterfaceType", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_CategoryInterfaceType_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_CategoryImplementationType_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_CategoryImplementationTypeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.CategoryImplementationType", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_CategoryImplementationType_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ProtocolInterfaceType_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ProtocolInterfaceTypeType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ProtocolInterfaceType", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ProtocolInterfaceType_getset_table,
            .tp_base = (PyTypeObject*)&gcc_TypeType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_KeywordDecl_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_KeywordDeclType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.KeywordDecl", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_KeywordDecl_getset_table,
            .tp_base = (PyTypeObject*)&gcc_DeclarationType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_InstanceMethodDecl_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_InstanceMethodDeclType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.InstanceMethodDecl", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_InstanceMethodDecl_getset_table,
            .tp_base = (PyTypeObject*)&gcc_DeclarationType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ClassMethodDecl_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ClassMethodDeclType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ClassMethodDecl", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ClassMethodDecl_getset_table,
            .tp_base = (PyTypeObject*)&gcc_DeclarationType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_PropertyDecl_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_PropertyDeclType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.PropertyDecl", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_PropertyDecl_getset_table,
            .tp_base = (PyTypeObject*)&gcc_DeclarationType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_MessageSendExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_MessageSendExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.MessageSendExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_MessageSendExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_ClassReferenceExpr_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_ClassReferenceExprType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.ClassReferenceExpr", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_ClassReferenceExpr_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};

static PyGetSetDef gcc_PropertyRef_getset_table[] = {
    {NULL}  /* Sentinel */
};

PyGccWrapperTypeObject gcc_PropertyRefType = {
    .wrtp_base = {
        .ht_type = {
            PyVarObject_HEAD_INIT(&PyGccWrapperMetaType, 0)
            "gcc.PropertyRef", /*tp_name*/
            sizeof(PyGccTree), /*tp_basicsize*/
            0, /*tp_itemsize*/
            .tp_dealloc = NULL,
            .tp_print = NULL,
            .tp_getattr = NULL,
            .tp_setattr = NULL,
        #if PY_MAJOR_VERSION < 3
            0, /*tp_compare*/
        #else
            0, /*reserved*/
        #endif
            .tp_repr = NULL,
            .tp_as_number = NULL,
            .tp_as_sequence = NULL,
            .tp_as_mapping = NULL,
            .tp_hash = NULL,
            .tp_call = NULL,
            .tp_str = NULL,
            .tp_getattro = NULL,
            .tp_setattro = NULL,
            .tp_as_buffer = NULL,
            .tp_flags = Py_TPFLAGS_DEFAULT,
            0, /*tp_doc*/
            .tp_traverse = NULL,
            .tp_clear = NULL,
            .tp_richcompare = NULL,
            0, /* tp_weaklistoffset */
            .tp_iter = NULL,
            .tp_iternext = NULL,
            .tp_methods = NULL,
            .tp_members = NULL,
            .tp_getset = gcc_PropertyRef_getset_table,
            .tp_base = (PyTypeObject*)&gcc_ExpressionType,
            .tp_dict = NULL,
            .tp_descr_get = NULL,
            .tp_descr_set = NULL,
            0, /* tp_dictoffset */
            .tp_init = (initproc)NULL,
            .tp_alloc = NULL,
            .tp_new = PyType_GenericNew,
            .tp_free = NULL,
            .tp_is_gc = NULL,
            .tp_bases = NULL,
            .tp_mro = NULL,
            .tp_cache = NULL,
            .tp_subclasses = NULL,
            .tp_weaklist = NULL,
            .tp_del = NULL,
        #if PY_VERSION_HEX >= 0x02060000
            0, /*tp_version_tag*/
        #endif
        },
    },
    .wrtp_mark = (wrtp_marker)wrtp_mark_for_PyGccTree,
};


/* Map from GCC tree codes to PyGccWrapperTypeObject* */
PyGccWrapperTypeObject *pytype_for_tree_code[] = {
    &gcc_ErrorMarkType, /* ERROR_MARK */
    &gcc_IdentifierNodeType, /* IDENTIFIER_NODE */
    &gcc_TreeListType, /* TREE_LIST */
    &gcc_TreeVecType, /* TREE_VEC */
    &gcc_BlockType, /* BLOCK */
    &gcc_OffsetTypeType, /* OFFSET_TYPE */
    &gcc_EnumeralTypeType, /* ENUMERAL_TYPE */
    &gcc_BooleanTypeType, /* BOOLEAN_TYPE */
    &gcc_IntegerTypeType, /* INTEGER_TYPE */
    &gcc_RealTypeType, /* REAL_TYPE */
    &gcc_PointerTypeType, /* POINTER_TYPE */
    &gcc_ReferenceTypeType, /* REFERENCE_TYPE */
    &gcc_NullptrTypeType, /* NULLPTR_TYPE */
    &gcc_FixedPointTypeType, /* FIXED_POINT_TYPE */
    &gcc_ComplexTypeType, /* COMPLEX_TYPE */
    &gcc_VectorTypeType, /* VECTOR_TYPE */
    &gcc_ArrayTypeType, /* ARRAY_TYPE */
    &gcc_RecordTypeType, /* RECORD_TYPE */
    &gcc_UnionTypeType, /* UNION_TYPE */
    &gcc_QualUnionTypeType, /* QUAL_UNION_TYPE */
    &gcc_VoidTypeType, /* VOID_TYPE */
    &gcc_FunctionTypeType, /* FUNCTION_TYPE */
    &gcc_MethodTypeType, /* METHOD_TYPE */
    &gcc_LangTypeType, /* LANG_TYPE */
    &gcc_IntegerCstType, /* INTEGER_CST */
    &gcc_RealCstType, /* REAL_CST */
    &gcc_FixedCstType, /* FIXED_CST */
    &gcc_ComplexCstType, /* COMPLEX_CST */
    &gcc_VectorCstType, /* VECTOR_CST */
    &gcc_StringCstType, /* STRING_CST */
    &gcc_FunctionDeclType, /* FUNCTION_DECL */
    &gcc_LabelDeclType, /* LABEL_DECL */
    &gcc_FieldDeclType, /* FIELD_DECL */
    &gcc_VarDeclType, /* VAR_DECL */
    &gcc_ConstDeclType, /* CONST_DECL */
    &gcc_ParmDeclType, /* PARM_DECL */
    &gcc_TypeDeclType, /* TYPE_DECL */
    &gcc_ResultDeclType, /* RESULT_DECL */
    &gcc_DebugExprDeclType, /* DEBUG_EXPR_DECL */
    &gcc_NamespaceDeclType, /* NAMESPACE_DECL */
    &gcc_ImportedDeclType, /* IMPORTED_DECL */
    &gcc_TranslationUnitDeclType, /* TRANSLATION_UNIT_DECL */
    &gcc_ComponentRefType, /* COMPONENT_REF */
    &gcc_BitFieldRefType, /* BIT_FIELD_REF */
    &gcc_RealpartExprType, /* REALPART_EXPR */
    &gcc_ImagpartExprType, /* IMAGPART_EXPR */
    &gcc_ArrayRefType, /* ARRAY_REF */
    &gcc_ArrayRangeRefType, /* ARRAY_RANGE_REF */
    &gcc_IndirectRefType, /* INDIRECT_REF */
    &gcc_ObjTypeRefType, /* OBJ_TYPE_REF */
    &gcc_ConstructorType, /* CONSTRUCTOR */
    &gcc_CompoundExprType, /* COMPOUND_EXPR */
    &gcc_ModifyExprType, /* MODIFY_EXPR */
    &gcc_InitExprType, /* INIT_EXPR */
    &gcc_TargetExprType, /* TARGET_EXPR */
    &gcc_CondExprType, /* COND_EXPR */
    &gcc_VecCondExprType, /* VEC_COND_EXPR */
    &gcc_VecPermExprType, /* VEC_PERM_EXPR */
    &gcc_BindExprType, /* BIND_EXPR */
    &gcc_CallExprType, /* CALL_EXPR */
    &gcc_WithCleanupExprType, /* WITH_CLEANUP_EXPR */
    &gcc_CleanupPointExprType, /* CLEANUP_POINT_EXPR */
    &gcc_PlaceholderExprType, /* PLACEHOLDER_EXPR */
    &gcc_PlusExprType, /* PLUS_EXPR */
    &gcc_MinusExprType, /* MINUS_EXPR */
    &gcc_MultExprType, /* MULT_EXPR */
    &gcc_PointerPlusExprType, /* POINTER_PLUS_EXPR */
    &gcc_TruncDivExprType, /* TRUNC_DIV_EXPR */
    &gcc_CeilDivExprType, /* CEIL_DIV_EXPR */
    &gcc_FloorDivExprType, /* FLOOR_DIV_EXPR */
    &gcc_RoundDivExprType, /* ROUND_DIV_EXPR */
    &gcc_TruncModExprType, /* TRUNC_MOD_EXPR */
    &gcc_CeilModExprType, /* CEIL_MOD_EXPR */
    &gcc_FloorModExprType, /* FLOOR_MOD_EXPR */
    &gcc_RoundModExprType, /* ROUND_MOD_EXPR */
    &gcc_RdivExprType, /* RDIV_EXPR */
    &gcc_ExactDivExprType, /* EXACT_DIV_EXPR */
    &gcc_FixTruncExprType, /* FIX_TRUNC_EXPR */
    &gcc_FloatExprType, /* FLOAT_EXPR */
    &gcc_NegateExprType, /* NEGATE_EXPR */
    &gcc_MinExprType, /* MIN_EXPR */
    &gcc_MaxExprType, /* MAX_EXPR */
    &gcc_AbsExprType, /* ABS_EXPR */
    &gcc_LshiftExprType, /* LSHIFT_EXPR */
    &gcc_RshiftExprType, /* RSHIFT_EXPR */
    &gcc_LrotateExprType, /* LROTATE_EXPR */
    &gcc_RrotateExprType, /* RROTATE_EXPR */
    &gcc_BitIorExprType, /* BIT_IOR_EXPR */
    &gcc_BitXorExprType, /* BIT_XOR_EXPR */
    &gcc_BitAndExprType, /* BIT_AND_EXPR */
    &gcc_BitNotExprType, /* BIT_NOT_EXPR */
    &gcc_TruthAndifExprType, /* TRUTH_ANDIF_EXPR */
    &gcc_TruthOrifExprType, /* TRUTH_ORIF_EXPR */
    &gcc_TruthAndExprType, /* TRUTH_AND_EXPR */
    &gcc_TruthOrExprType, /* TRUTH_OR_EXPR */
    &gcc_TruthXorExprType, /* TRUTH_XOR_EXPR */
    &gcc_TruthNotExprType, /* TRUTH_NOT_EXPR */
    &gcc_LtExprType, /* LT_EXPR */
    &gcc_LeExprType, /* LE_EXPR */
    &gcc_GtExprType, /* GT_EXPR */
    &gcc_GeExprType, /* GE_EXPR */
    &gcc_EqExprType, /* EQ_EXPR */
    &gcc_NeExprType, /* NE_EXPR */
    &gcc_UnorderedExprType, /* UNORDERED_EXPR */
    &gcc_OrderedExprType, /* ORDERED_EXPR */
    &gcc_UnltExprType, /* UNLT_EXPR */
    &gcc_UnleExprType, /* UNLE_EXPR */
    &gcc_UngtExprType, /* UNGT_EXPR */
    &gcc_UngeExprType, /* UNGE_EXPR */
    &gcc_UneqExprType, /* UNEQ_EXPR */
    &gcc_LtgtExprType, /* LTGT_EXPR */
    &gcc_RangeExprType, /* RANGE_EXPR */
    &gcc_ParenExprType, /* PAREN_EXPR */
    &gcc_ConvertExprType, /* CONVERT_EXPR */
    &gcc_AddrSpaceConvertExprType, /* ADDR_SPACE_CONVERT_EXPR */
    &gcc_FixedConvertExprType, /* FIXED_CONVERT_EXPR */
    &gcc_NopExprType, /* NOP_EXPR */
    &gcc_NonLvalueExprType, /* NON_LVALUE_EXPR */
    &gcc_ViewConvertExprType, /* VIEW_CONVERT_EXPR */
    &gcc_CompoundLiteralExprType, /* COMPOUND_LITERAL_EXPR */
    &gcc_SaveExprType, /* SAVE_EXPR */
    &gcc_AddrExprType, /* ADDR_EXPR */
    &gcc_FdescExprType, /* FDESC_EXPR */
    &gcc_ComplexExprType, /* COMPLEX_EXPR */
    &gcc_ConjExprType, /* CONJ_EXPR */
    &gcc_PredecrementExprType, /* PREDECREMENT_EXPR */
    &gcc_PreincrementExprType, /* PREINCREMENT_EXPR */
    &gcc_PostdecrementExprType, /* POSTDECREMENT_EXPR */
    &gcc_PostincrementExprType, /* POSTINCREMENT_EXPR */
    &gcc_VaArgExprType, /* VA_ARG_EXPR */
    &gcc_TryCatchExprType, /* TRY_CATCH_EXPR */
    &gcc_TryFinallyType, /* TRY_FINALLY_EXPR */
    &gcc_DeclExprType, /* DECL_EXPR */
    &gcc_LabelExprType, /* LABEL_EXPR */
    &gcc_GotoExprType, /* GOTO_EXPR */
    &gcc_ReturnExprType, /* RETURN_EXPR */
    &gcc_ExitExprType, /* EXIT_EXPR */
    &gcc_LoopExprType, /* LOOP_EXPR */
    &gcc_SwitchExprType, /* SWITCH_EXPR */
    &gcc_CaseLabelExprType, /* CASE_LABEL_EXPR */
    &gcc_AsmExprType, /* ASM_EXPR */
    &gcc_SsaNameType, /* SSA_NAME */
    &gcc_CatchExprType, /* CATCH_EXPR */
    &gcc_EhFilterExprType, /* EH_FILTER_EXPR */
    &gcc_ScevKnownType, /* SCEV_KNOWN */
    &gcc_ScevNotKnownType, /* SCEV_NOT_KNOWN */
    &gcc_PolynomialChrecType, /* POLYNOMIAL_CHREC */
    &gcc_StatementListType, /* STATEMENT_LIST */
    &gcc_AssertExprType, /* ASSERT_EXPR */
    &gcc_TreeBinfoType, /* TREE_BINFO */
    &gcc_WithSizeExprType, /* WITH_SIZE_EXPR */
    &gcc_RealignLoadType, /* REALIGN_LOAD_EXPR */
    &gcc_TargetMemRefType, /* TARGET_MEM_REF */
    &gcc_MemRefType, /* MEM_REF */
    &gcc_OmpParallelType, /* OMP_PARALLEL */
    &gcc_OmpTaskType, /* OMP_TASK */
    &gcc_OmpForType, /* OMP_FOR */
    &gcc_OmpSectionsType, /* OMP_SECTIONS */
    &gcc_OmpSingleType, /* OMP_SINGLE */
    &gcc_OmpSectionType, /* OMP_SECTION */
    &gcc_OmpMasterType, /* OMP_MASTER */
    &gcc_OmpOrderedType, /* OMP_ORDERED */
    &gcc_OmpCriticalType, /* OMP_CRITICAL */
    &gcc_OmpAtomicType, /* OMP_ATOMIC */
    &gcc_OmpAtomicReadType, /* OMP_ATOMIC_READ */
    &gcc_OmpAtomicCaptureOldType, /* OMP_ATOMIC_CAPTURE_OLD */
    &gcc_OmpAtomicCaptureNewType, /* OMP_ATOMIC_CAPTURE_NEW */
    &gcc_OmpClauseType, /* OMP_CLAUSE */
    &gcc_TransactionExprType, /* TRANSACTION_EXPR */
    &gcc_ReducMaxExprType, /* REDUC_MAX_EXPR */
    &gcc_ReducMinExprType, /* REDUC_MIN_EXPR */
    &gcc_ReducPlusExprType, /* REDUC_PLUS_EXPR */
    &gcc_DotProdExprType, /* DOT_PROD_EXPR */
    &gcc_WidenSumExprType, /* WIDEN_SUM_EXPR */
    &gcc_WidenMultExprType, /* WIDEN_MULT_EXPR */
    &gcc_WidenMultPlusExprType, /* WIDEN_MULT_PLUS_EXPR */
    &gcc_WidenMultMinusExprType, /* WIDEN_MULT_MINUS_EXPR */
    &gcc_WidenLshiftExprType, /* WIDEN_LSHIFT_EXPR */
    &gcc_FmaExprType, /* FMA_EXPR */
    &gcc_VecLshiftExprType, /* VEC_LSHIFT_EXPR */
    &gcc_VecRshiftExprType, /* VEC_RSHIFT_EXPR */
    &gcc_WidenMultHiExprType, /* VEC_WIDEN_MULT_HI_EXPR */
    &gcc_WidenMultLoExprType, /* VEC_WIDEN_MULT_LO_EXPR */
    &gcc_VecUnpackHiExprType, /* VEC_UNPACK_HI_EXPR */
    &gcc_VecUnpackLoExprType, /* VEC_UNPACK_LO_EXPR */
    &gcc_VecUnpackFloatHiExprType, /* VEC_UNPACK_FLOAT_HI_EXPR */
    &gcc_VecUnpackFloatLoExprType, /* VEC_UNPACK_FLOAT_LO_EXPR */
    &gcc_VecPackTruncExprType, /* VEC_PACK_TRUNC_EXPR */
    &gcc_VecPackSatExprType, /* VEC_PACK_SAT_EXPR */
    &gcc_VecPackFixTruncExprType, /* VEC_PACK_FIX_TRUNC_EXPR */
    &gcc_WidenLshiftHiExprType, /* VEC_WIDEN_LSHIFT_HI_EXPR */
    &gcc_WidenLshiftLoExprType, /* VEC_WIDEN_LSHIFT_LO_EXPR */
    &gcc_PredictExprType, /* PREDICT_EXPR */
    &gcc_OptimizationNodeType, /* OPTIMIZATION_NODE */
    &gcc_TargetOptionNodeType, /* TARGET_OPTION_NODE */
    &gcc_CMaybeConstExprType, /* C_MAYBE_CONST_EXPR */
    &gcc_ExcessPrecisionExprType, /* EXCESS_PRECISION_EXPR */
    &gcc_UserdefLiteralType, /* USERDEF_LITERAL */
    &gcc_UnconstrainedArrayTypeType, /* UNCONSTRAINED_ARRAY_TYPE */
    &gcc_UnconstrainedArrayRefType, /* UNCONSTRAINED_ARRAY_REF */
    &gcc_NullExprType, /* NULL_EXPR */
    &gcc_PlusNomodExprType, /* PLUS_NOMOD_EXPR */
    &gcc_MinusNomodExprType, /* MINUS_NOMOD_EXPR */
    &gcc_AttrAddrExprType, /* ATTR_ADDR_EXPR */
    &gcc_StmtStmtType, /* STMT_STMT */
    &gcc_LoopStmtType, /* LOOP_STMT */
    &gcc_ExitStmtType, /* EXIT_STMT */
    &gcc_OffsetRefType, /* OFFSET_REF */
    &gcc_PtrmemCstType, /* PTRMEM_CST */
    &gcc_NwExprType, /* NEW_EXPR */
    &gcc_VecNwExprType, /* VEC_NEW_EXPR */
    &gcc_DlExprType, /* DELETE_EXPR */
    &gcc_VecDlExprType, /* VEC_DELETE_EXPR */
    &gcc_ScopeRefType, /* SCOPE_REF */
    &gcc_MemberRefType, /* MEMBER_REF */
    &gcc_TypeExprType, /* TYPE_EXPR */
    &gcc_AggrInitExprType, /* AGGR_INIT_EXPR */
    &gcc_VecInitExprType, /* VEC_INIT_EXPR */
    &gcc_ThrowExprType, /* THROW_EXPR */
    &gcc_EmptyClassExprType, /* EMPTY_CLASS_EXPR */
    &gcc_BaselinkType, /* BASELINK */
    &gcc_TemplateDeclType, /* TEMPLATE_DECL */
    &gcc_TemplateParmIndexType, /* TEMPLATE_PARM_INDEX */
    &gcc_TemplateTemplateParmType, /* TEMPLATE_TEMPLATE_PARM */
    &gcc_TemplateTypeParmType, /* TEMPLATE_TYPE_PARM */
    &gcc_TypenameTypeType, /* TYPENAME_TYPE */
    &gcc_TypeofTypeType, /* TYPEOF_TYPE */
    &gcc_BoundTemplateTemplateParmType, /* BOUND_TEMPLATE_TEMPLATE_PARM */
    &gcc_UnboundClassTemplateType, /* UNBOUND_CLASS_TEMPLATE */
    &gcc_UsingDeclType, /* USING_DECL */
    &gcc_UsingStmtType, /* USING_STMT */
    &gcc_DefaultArgType, /* DEFAULT_ARG */
    &gcc_DeferredNoexceptType, /* DEFERRED_NOEXCEPT */
    &gcc_TemplateIdExprType, /* TEMPLATE_ID_EXPR */
    &gcc_OverloadType, /* OVERLOAD */
    &gcc_PseudoDtorExprType, /* PSEUDO_DTOR_EXPR */
    &gcc_ModopExprType, /* MODOP_EXPR */
    &gcc_CastExprType, /* CAST_EXPR */
    &gcc_ReinterpretCastExprType, /* REINTERPRET_CAST_EXPR */
    &gcc_ConstCastExprType, /* CONST_CAST_EXPR */
    &gcc_StaticCastExprType, /* STATIC_CAST_EXPR */
    &gcc_DynamicCastExprType, /* DYNAMIC_CAST_EXPR */
    &gcc_ImplicitConvExprType, /* IMPLICIT_CONV_EXPR */
    &gcc_DotstarExprType, /* DOTSTAR_EXPR */
    &gcc_TypeidExprType, /* TYPEID_EXPR */
    &gcc_NoexceptExprType, /* NOEXCEPT_EXPR */
    &gcc_NonDependentExprType, /* NON_DEPENDENT_EXPR */
    &gcc_CtorInitializerType, /* CTOR_INITIALIZER */
    &gcc_TryBlockType, /* TRY_BLOCK */
    &gcc_EhSpecBlockType, /* EH_SPEC_BLOCK */
    &gcc_HandlerType, /* HANDLER */
    &gcc_MustNotThrowExprType, /* MUST_NOT_THROW_EXPR */
    &gcc_CleanupStmtType, /* CLEANUP_STMT */
    &gcc_IfStmtType, /* IF_STMT */
    &gcc_ForStmtType, /* FOR_STMT */
    &gcc_RangeForStmtType, /* RANGE_FOR_STMT */
    &gcc_WhileStmtType, /* WHILE_STMT */
    &gcc_DoStmtType, /* DO_STMT */
    &gcc_BreakStmtType, /* BREAK_STMT */
    &gcc_ContinueStmtType, /* CONTINUE_STMT */
    &gcc_SwitchStmtType, /* SWITCH_STMT */
    &gcc_ExprStmtType, /* EXPR_STMT */
    &gcc_TagDefnType, /* TAG_DEFN */
    &gcc_OffsetofExprType, /* OFFSETOF_EXPR */
    &gcc_SizeofExprType, /* SIZEOF_EXPR */
    &gcc_ArrowExprType, /* ARROW_EXPR */
    &gcc_AlignofExprType, /* ALIGNOF_EXPR */
    &gcc_AtEncodeExprType, /* AT_ENCODE_EXPR */
    &gcc_StmtExprType, /* STMT_EXPR */
    &gcc_UnaryPlusExprType, /* UNARY_PLUS_EXPR */
    &gcc_StaticAssertType, /* STATIC_ASSERT */
    &gcc_TypeArgumentPackType, /* TYPE_ARGUMENT_PACK */
    &gcc_NontypeArgumentPackType, /* NONTYPE_ARGUMENT_PACK */
    &gcc_TypePackExpansionType, /* TYPE_PACK_EXPANSION */
    &gcc_ExprPackExpansionType, /* EXPR_PACK_EXPANSION */
    &gcc_ArgumentPackSelectType, /* ARGUMENT_PACK_SELECT */
    &gcc_TraitExprType, /* TRAIT_EXPR */
    &gcc_LambdaExprType, /* LAMBDA_EXPR */
    &gcc_DecltypeTypeType, /* DECLTYPE_TYPE */
    &gcc_UnderlyingTypeType, /* UNDERLYING_TYPE */
    &gcc_BasesType, /* BASES */
    &gcc_TemplateInfoType, /* TEMPLATE_INFO */
    &gcc_UrshiftExprType, /* URSHIFT_EXPR */
    &gcc_CompareExprType, /* COMPARE_EXPR */
    &gcc_CompareLExprType, /* COMPARE_L_EXPR */
    &gcc_CompareGExprType, /* COMPARE_G_EXPR */
    &gcc_ClassInterfaceTypeType, /* CLASS_INTERFACE_TYPE */
    &gcc_ClassImplementationTypeType, /* CLASS_IMPLEMENTATION_TYPE */
    &gcc_CategoryInterfaceTypeType, /* CATEGORY_INTERFACE_TYPE */
    &gcc_CategoryImplementationTypeType, /* CATEGORY_IMPLEMENTATION_TYPE */
    &gcc_ProtocolInterfaceTypeType, /* PROTOCOL_INTERFACE_TYPE */
    &gcc_KeywordDeclType, /* KEYWORD_DECL */
    &gcc_InstanceMethodDeclType, /* INSTANCE_METHOD_DECL */
    &gcc_ClassMethodDeclType, /* CLASS_METHOD_DECL */
    &gcc_PropertyDeclType, /* PROPERTY_DECL */
    &gcc_MessageSendExprType, /* MESSAGE_SEND_EXPR */
    &gcc_ClassReferenceExprType, /* CLASS_REFERENCE_EXPR */
    &gcc_PropertyRefType, /* PROPERTY_REF */
};


/* Map from PyGccWrapperTypeObject* to GCC tree codes*/
int 
gcc_python_tree_type_object_as_tree_code(PyObject *cls, enum tree_code *out)
{
    if (cls == (PyObject*)&gcc_ErrorMarkType) {
        *out = ERROR_MARK; return 0;
    }
    if (cls == (PyObject*)&gcc_IdentifierNodeType) {
        *out = IDENTIFIER_NODE; return 0;
    }
    if (cls == (PyObject*)&gcc_TreeListType) {
        *out = TREE_LIST; return 0;
    }
    if (cls == (PyObject*)&gcc_TreeVecType) {
        *out = TREE_VEC; return 0;
    }
    if (cls == (PyObject*)&gcc_BlockType) {
        *out = BLOCK; return 0;
    }
    if (cls == (PyObject*)&gcc_OffsetTypeType) {
        *out = OFFSET_TYPE; return 0;
    }
    if (cls == (PyObject*)&gcc_EnumeralTypeType) {
        *out = ENUMERAL_TYPE; return 0;
    }
    if (cls == (PyObject*)&gcc_BooleanTypeType) {
        *out = BOOLEAN_TYPE; return 0;
    }
    if (cls == (PyObject*)&gcc_IntegerTypeType) {
        *out = INTEGER_TYPE; return 0;
    }
    if (cls == (PyObject*)&gcc_RealTypeType) {
        *out = REAL_TYPE; return 0;
    }
    if (cls == (PyObject*)&gcc_PointerTypeType) {
        *out = POINTER_TYPE; return 0;
    }
    if (cls == (PyObject*)&gcc_ReferenceTypeType) {
        *out = REFERENCE_TYPE; return 0;
    }
    if (cls == (PyObject*)&gcc_NullptrTypeType) {
        *out = NULLPTR_TYPE; return 0;
    }
    if (cls == (PyObject*)&gcc_FixedPointTypeType) {
        *out = FIXED_POINT_TYPE; return 0;
    }
    if (cls == (PyObject*)&gcc_ComplexTypeType) {
        *out = COMPLEX_TYPE; return 0;
    }
    if (cls == (PyObject*)&gcc_VectorTypeType) {
        *out = VECTOR_TYPE; return 0;
    }
    if (cls == (PyObject*)&gcc_ArrayTypeType) {
        *out = ARRAY_TYPE; return 0;
    }
    if (cls == (PyObject*)&gcc_RecordTypeType) {
        *out = RECORD_TYPE; return 0;
    }
    if (cls == (PyObject*)&gcc_UnionTypeType) {
        *out = UNION_TYPE; return 0;
    }
    if (cls == (PyObject*)&gcc_QualUnionTypeType) {
        *out = QUAL_UNION_TYPE; return 0;
    }
    if (cls == (PyObject*)&gcc_VoidTypeType) {
        *out = VOID_TYPE; return 0;
    }
    if (cls == (PyObject*)&gcc_FunctionTypeType) {
        *out = FUNCTION_TYPE; return 0;
    }
    if (cls == (PyObject*)&gcc_MethodTypeType) {
        *out = METHOD_TYPE; return 0;
    }
    if (cls == (PyObject*)&gcc_LangTypeType) {
        *out = LANG_TYPE; return 0;
    }
    if (cls == (PyObject*)&gcc_IntegerCstType) {
        *out = INTEGER_CST; return 0;
    }
    if (cls == (PyObject*)&gcc_RealCstType) {
        *out = REAL_CST; return 0;
    }
    if (cls == (PyObject*)&gcc_FixedCstType) {
        *out = FIXED_CST; return 0;
    }
    if (cls == (PyObject*)&gcc_ComplexCstType) {
        *out = COMPLEX_CST; return 0;
    }
    if (cls == (PyObject*)&gcc_VectorCstType) {
        *out = VECTOR_CST; return 0;
    }
    if (cls == (PyObject*)&gcc_StringCstType) {
        *out = STRING_CST; return 0;
    }
    if (cls == (PyObject*)&gcc_FunctionDeclType) {
        *out = FUNCTION_DECL; return 0;
    }
    if (cls == (PyObject*)&gcc_LabelDeclType) {
        *out = LABEL_DECL; return 0;
    }
    if (cls == (PyObject*)&gcc_FieldDeclType) {
        *out = FIELD_DECL; return 0;
    }
    if (cls == (PyObject*)&gcc_VarDeclType) {
        *out = VAR_DECL; return 0;
    }
    if (cls == (PyObject*)&gcc_ConstDeclType) {
        *out = CONST_DECL; return 0;
    }
    if (cls == (PyObject*)&gcc_ParmDeclType) {
        *out = PARM_DECL; return 0;
    }
    if (cls == (PyObject*)&gcc_TypeDeclType) {
        *out = TYPE_DECL; return 0;
    }
    if (cls == (PyObject*)&gcc_ResultDeclType) {
        *out = RESULT_DECL; return 0;
    }
    if (cls == (PyObject*)&gcc_DebugExprDeclType) {
        *out = DEBUG_EXPR_DECL; return 0;
    }
    if (cls == (PyObject*)&gcc_NamespaceDeclType) {
        *out = NAMESPACE_DECL; return 0;
    }
    if (cls == (PyObject*)&gcc_ImportedDeclType) {
        *out = IMPORTED_DECL; return 0;
    }
    if (cls == (PyObject*)&gcc_TranslationUnitDeclType) {
        *out = TRANSLATION_UNIT_DECL; return 0;
    }
    if (cls == (PyObject*)&gcc_ComponentRefType) {
        *out = COMPONENT_REF; return 0;
    }
    if (cls == (PyObject*)&gcc_BitFieldRefType) {
        *out = BIT_FIELD_REF; return 0;
    }
    if (cls == (PyObject*)&gcc_RealpartExprType) {
        *out = REALPART_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_ImagpartExprType) {
        *out = IMAGPART_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_ArrayRefType) {
        *out = ARRAY_REF; return 0;
    }
    if (cls == (PyObject*)&gcc_ArrayRangeRefType) {
        *out = ARRAY_RANGE_REF; return 0;
    }
    if (cls == (PyObject*)&gcc_IndirectRefType) {
        *out = INDIRECT_REF; return 0;
    }
    if (cls == (PyObject*)&gcc_ObjTypeRefType) {
        *out = OBJ_TYPE_REF; return 0;
    }
    if (cls == (PyObject*)&gcc_ConstructorType) {
        *out = CONSTRUCTOR; return 0;
    }
    if (cls == (PyObject*)&gcc_CompoundExprType) {
        *out = COMPOUND_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_ModifyExprType) {
        *out = MODIFY_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_InitExprType) {
        *out = INIT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_TargetExprType) {
        *out = TARGET_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_CondExprType) {
        *out = COND_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_VecCondExprType) {
        *out = VEC_COND_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_VecPermExprType) {
        *out = VEC_PERM_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_BindExprType) {
        *out = BIND_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_CallExprType) {
        *out = CALL_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_WithCleanupExprType) {
        *out = WITH_CLEANUP_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_CleanupPointExprType) {
        *out = CLEANUP_POINT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_PlaceholderExprType) {
        *out = PLACEHOLDER_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_PlusExprType) {
        *out = PLUS_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_MinusExprType) {
        *out = MINUS_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_MultExprType) {
        *out = MULT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_PointerPlusExprType) {
        *out = POINTER_PLUS_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_TruncDivExprType) {
        *out = TRUNC_DIV_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_CeilDivExprType) {
        *out = CEIL_DIV_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_FloorDivExprType) {
        *out = FLOOR_DIV_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_RoundDivExprType) {
        *out = ROUND_DIV_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_TruncModExprType) {
        *out = TRUNC_MOD_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_CeilModExprType) {
        *out = CEIL_MOD_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_FloorModExprType) {
        *out = FLOOR_MOD_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_RoundModExprType) {
        *out = ROUND_MOD_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_RdivExprType) {
        *out = RDIV_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_ExactDivExprType) {
        *out = EXACT_DIV_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_FixTruncExprType) {
        *out = FIX_TRUNC_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_FloatExprType) {
        *out = FLOAT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_NegateExprType) {
        *out = NEGATE_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_MinExprType) {
        *out = MIN_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_MaxExprType) {
        *out = MAX_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_AbsExprType) {
        *out = ABS_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_LshiftExprType) {
        *out = LSHIFT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_RshiftExprType) {
        *out = RSHIFT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_LrotateExprType) {
        *out = LROTATE_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_RrotateExprType) {
        *out = RROTATE_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_BitIorExprType) {
        *out = BIT_IOR_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_BitXorExprType) {
        *out = BIT_XOR_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_BitAndExprType) {
        *out = BIT_AND_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_BitNotExprType) {
        *out = BIT_NOT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_TruthAndifExprType) {
        *out = TRUTH_ANDIF_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_TruthOrifExprType) {
        *out = TRUTH_ORIF_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_TruthAndExprType) {
        *out = TRUTH_AND_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_TruthOrExprType) {
        *out = TRUTH_OR_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_TruthXorExprType) {
        *out = TRUTH_XOR_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_TruthNotExprType) {
        *out = TRUTH_NOT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_LtExprType) {
        *out = LT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_LeExprType) {
        *out = LE_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_GtExprType) {
        *out = GT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_GeExprType) {
        *out = GE_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_EqExprType) {
        *out = EQ_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_NeExprType) {
        *out = NE_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_UnorderedExprType) {
        *out = UNORDERED_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_OrderedExprType) {
        *out = ORDERED_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_UnltExprType) {
        *out = UNLT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_UnleExprType) {
        *out = UNLE_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_UngtExprType) {
        *out = UNGT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_UngeExprType) {
        *out = UNGE_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_UneqExprType) {
        *out = UNEQ_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_LtgtExprType) {
        *out = LTGT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_RangeExprType) {
        *out = RANGE_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_ParenExprType) {
        *out = PAREN_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_ConvertExprType) {
        *out = CONVERT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_AddrSpaceConvertExprType) {
        *out = ADDR_SPACE_CONVERT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_FixedConvertExprType) {
        *out = FIXED_CONVERT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_NopExprType) {
        *out = NOP_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_NonLvalueExprType) {
        *out = NON_LVALUE_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_ViewConvertExprType) {
        *out = VIEW_CONVERT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_CompoundLiteralExprType) {
        *out = COMPOUND_LITERAL_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_SaveExprType) {
        *out = SAVE_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_AddrExprType) {
        *out = ADDR_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_FdescExprType) {
        *out = FDESC_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_ComplexExprType) {
        *out = COMPLEX_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_ConjExprType) {
        *out = CONJ_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_PredecrementExprType) {
        *out = PREDECREMENT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_PreincrementExprType) {
        *out = PREINCREMENT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_PostdecrementExprType) {
        *out = POSTDECREMENT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_PostincrementExprType) {
        *out = POSTINCREMENT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_VaArgExprType) {
        *out = VA_ARG_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_TryCatchExprType) {
        *out = TRY_CATCH_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_TryFinallyType) {
        *out = TRY_FINALLY_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_DeclExprType) {
        *out = DECL_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_LabelExprType) {
        *out = LABEL_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_GotoExprType) {
        *out = GOTO_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_ReturnExprType) {
        *out = RETURN_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_ExitExprType) {
        *out = EXIT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_LoopExprType) {
        *out = LOOP_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_SwitchExprType) {
        *out = SWITCH_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_CaseLabelExprType) {
        *out = CASE_LABEL_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_AsmExprType) {
        *out = ASM_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_SsaNameType) {
        *out = SSA_NAME; return 0;
    }
    if (cls == (PyObject*)&gcc_CatchExprType) {
        *out = CATCH_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_EhFilterExprType) {
        *out = EH_FILTER_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_ScevKnownType) {
        *out = SCEV_KNOWN; return 0;
    }
    if (cls == (PyObject*)&gcc_ScevNotKnownType) {
        *out = SCEV_NOT_KNOWN; return 0;
    }
    if (cls == (PyObject*)&gcc_PolynomialChrecType) {
        *out = POLYNOMIAL_CHREC; return 0;
    }
    if (cls == (PyObject*)&gcc_StatementListType) {
        *out = STATEMENT_LIST; return 0;
    }
    if (cls == (PyObject*)&gcc_AssertExprType) {
        *out = ASSERT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_TreeBinfoType) {
        *out = TREE_BINFO; return 0;
    }
    if (cls == (PyObject*)&gcc_WithSizeExprType) {
        *out = WITH_SIZE_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_RealignLoadType) {
        *out = REALIGN_LOAD_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_TargetMemRefType) {
        *out = TARGET_MEM_REF; return 0;
    }
    if (cls == (PyObject*)&gcc_MemRefType) {
        *out = MEM_REF; return 0;
    }
    if (cls == (PyObject*)&gcc_OmpParallelType) {
        *out = OMP_PARALLEL; return 0;
    }
    if (cls == (PyObject*)&gcc_OmpTaskType) {
        *out = OMP_TASK; return 0;
    }
    if (cls == (PyObject*)&gcc_OmpForType) {
        *out = OMP_FOR; return 0;
    }
    if (cls == (PyObject*)&gcc_OmpSectionsType) {
        *out = OMP_SECTIONS; return 0;
    }
    if (cls == (PyObject*)&gcc_OmpSingleType) {
        *out = OMP_SINGLE; return 0;
    }
    if (cls == (PyObject*)&gcc_OmpSectionType) {
        *out = OMP_SECTION; return 0;
    }
    if (cls == (PyObject*)&gcc_OmpMasterType) {
        *out = OMP_MASTER; return 0;
    }
    if (cls == (PyObject*)&gcc_OmpOrderedType) {
        *out = OMP_ORDERED; return 0;
    }
    if (cls == (PyObject*)&gcc_OmpCriticalType) {
        *out = OMP_CRITICAL; return 0;
    }
    if (cls == (PyObject*)&gcc_OmpAtomicType) {
        *out = OMP_ATOMIC; return 0;
    }
    if (cls == (PyObject*)&gcc_OmpAtomicReadType) {
        *out = OMP_ATOMIC_READ; return 0;
    }
    if (cls == (PyObject*)&gcc_OmpAtomicCaptureOldType) {
        *out = OMP_ATOMIC_CAPTURE_OLD; return 0;
    }
    if (cls == (PyObject*)&gcc_OmpAtomicCaptureNewType) {
        *out = OMP_ATOMIC_CAPTURE_NEW; return 0;
    }
    if (cls == (PyObject*)&gcc_OmpClauseType) {
        *out = OMP_CLAUSE; return 0;
    }
    if (cls == (PyObject*)&gcc_TransactionExprType) {
        *out = TRANSACTION_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_ReducMaxExprType) {
        *out = REDUC_MAX_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_ReducMinExprType) {
        *out = REDUC_MIN_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_ReducPlusExprType) {
        *out = REDUC_PLUS_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_DotProdExprType) {
        *out = DOT_PROD_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_WidenSumExprType) {
        *out = WIDEN_SUM_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_WidenMultExprType) {
        *out = WIDEN_MULT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_WidenMultPlusExprType) {
        *out = WIDEN_MULT_PLUS_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_WidenMultMinusExprType) {
        *out = WIDEN_MULT_MINUS_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_WidenLshiftExprType) {
        *out = WIDEN_LSHIFT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_FmaExprType) {
        *out = FMA_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_VecLshiftExprType) {
        *out = VEC_LSHIFT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_VecRshiftExprType) {
        *out = VEC_RSHIFT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_WidenMultHiExprType) {
        *out = VEC_WIDEN_MULT_HI_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_WidenMultLoExprType) {
        *out = VEC_WIDEN_MULT_LO_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_VecUnpackHiExprType) {
        *out = VEC_UNPACK_HI_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_VecUnpackLoExprType) {
        *out = VEC_UNPACK_LO_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_VecUnpackFloatHiExprType) {
        *out = VEC_UNPACK_FLOAT_HI_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_VecUnpackFloatLoExprType) {
        *out = VEC_UNPACK_FLOAT_LO_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_VecPackTruncExprType) {
        *out = VEC_PACK_TRUNC_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_VecPackSatExprType) {
        *out = VEC_PACK_SAT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_VecPackFixTruncExprType) {
        *out = VEC_PACK_FIX_TRUNC_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_WidenLshiftHiExprType) {
        *out = VEC_WIDEN_LSHIFT_HI_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_WidenLshiftLoExprType) {
        *out = VEC_WIDEN_LSHIFT_LO_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_PredictExprType) {
        *out = PREDICT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_OptimizationNodeType) {
        *out = OPTIMIZATION_NODE; return 0;
    }
    if (cls == (PyObject*)&gcc_TargetOptionNodeType) {
        *out = TARGET_OPTION_NODE; return 0;
    }
    if (cls == (PyObject*)&gcc_CMaybeConstExprType) {
        *out = C_MAYBE_CONST_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_ExcessPrecisionExprType) {
        *out = EXCESS_PRECISION_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_UserdefLiteralType) {
        *out = USERDEF_LITERAL; return 0;
    }
    if (cls == (PyObject*)&gcc_UnconstrainedArrayTypeType) {
        *out = UNCONSTRAINED_ARRAY_TYPE; return 0;
    }
    if (cls == (PyObject*)&gcc_UnconstrainedArrayRefType) {
        *out = UNCONSTRAINED_ARRAY_REF; return 0;
    }
    if (cls == (PyObject*)&gcc_NullExprType) {
        *out = NULL_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_PlusNomodExprType) {
        *out = PLUS_NOMOD_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_MinusNomodExprType) {
        *out = MINUS_NOMOD_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_AttrAddrExprType) {
        *out = ATTR_ADDR_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_StmtStmtType) {
        *out = STMT_STMT; return 0;
    }
    if (cls == (PyObject*)&gcc_LoopStmtType) {
        *out = LOOP_STMT; return 0;
    }
    if (cls == (PyObject*)&gcc_ExitStmtType) {
        *out = EXIT_STMT; return 0;
    }
    if (cls == (PyObject*)&gcc_OffsetRefType) {
        *out = OFFSET_REF; return 0;
    }
    if (cls == (PyObject*)&gcc_PtrmemCstType) {
        *out = PTRMEM_CST; return 0;
    }
    if (cls == (PyObject*)&gcc_NwExprType) {
        *out = NEW_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_VecNwExprType) {
        *out = VEC_NEW_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_DlExprType) {
        *out = DELETE_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_VecDlExprType) {
        *out = VEC_DELETE_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_ScopeRefType) {
        *out = SCOPE_REF; return 0;
    }
    if (cls == (PyObject*)&gcc_MemberRefType) {
        *out = MEMBER_REF; return 0;
    }
    if (cls == (PyObject*)&gcc_TypeExprType) {
        *out = TYPE_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_AggrInitExprType) {
        *out = AGGR_INIT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_VecInitExprType) {
        *out = VEC_INIT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_ThrowExprType) {
        *out = THROW_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_EmptyClassExprType) {
        *out = EMPTY_CLASS_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_BaselinkType) {
        *out = BASELINK; return 0;
    }
    if (cls == (PyObject*)&gcc_TemplateDeclType) {
        *out = TEMPLATE_DECL; return 0;
    }
    if (cls == (PyObject*)&gcc_TemplateParmIndexType) {
        *out = TEMPLATE_PARM_INDEX; return 0;
    }
    if (cls == (PyObject*)&gcc_TemplateTemplateParmType) {
        *out = TEMPLATE_TEMPLATE_PARM; return 0;
    }
    if (cls == (PyObject*)&gcc_TemplateTypeParmType) {
        *out = TEMPLATE_TYPE_PARM; return 0;
    }
    if (cls == (PyObject*)&gcc_TypenameTypeType) {
        *out = TYPENAME_TYPE; return 0;
    }
    if (cls == (PyObject*)&gcc_TypeofTypeType) {
        *out = TYPEOF_TYPE; return 0;
    }
    if (cls == (PyObject*)&gcc_BoundTemplateTemplateParmType) {
        *out = BOUND_TEMPLATE_TEMPLATE_PARM; return 0;
    }
    if (cls == (PyObject*)&gcc_UnboundClassTemplateType) {
        *out = UNBOUND_CLASS_TEMPLATE; return 0;
    }
    if (cls == (PyObject*)&gcc_UsingDeclType) {
        *out = USING_DECL; return 0;
    }
    if (cls == (PyObject*)&gcc_UsingStmtType) {
        *out = USING_STMT; return 0;
    }
    if (cls == (PyObject*)&gcc_DefaultArgType) {
        *out = DEFAULT_ARG; return 0;
    }
    if (cls == (PyObject*)&gcc_DeferredNoexceptType) {
        *out = DEFERRED_NOEXCEPT; return 0;
    }
    if (cls == (PyObject*)&gcc_TemplateIdExprType) {
        *out = TEMPLATE_ID_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_OverloadType) {
        *out = OVERLOAD; return 0;
    }
    if (cls == (PyObject*)&gcc_PseudoDtorExprType) {
        *out = PSEUDO_DTOR_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_ModopExprType) {
        *out = MODOP_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_CastExprType) {
        *out = CAST_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_ReinterpretCastExprType) {
        *out = REINTERPRET_CAST_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_ConstCastExprType) {
        *out = CONST_CAST_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_StaticCastExprType) {
        *out = STATIC_CAST_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_DynamicCastExprType) {
        *out = DYNAMIC_CAST_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_ImplicitConvExprType) {
        *out = IMPLICIT_CONV_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_DotstarExprType) {
        *out = DOTSTAR_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_TypeidExprType) {
        *out = TYPEID_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_NoexceptExprType) {
        *out = NOEXCEPT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_NonDependentExprType) {
        *out = NON_DEPENDENT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_CtorInitializerType) {
        *out = CTOR_INITIALIZER; return 0;
    }
    if (cls == (PyObject*)&gcc_TryBlockType) {
        *out = TRY_BLOCK; return 0;
    }
    if (cls == (PyObject*)&gcc_EhSpecBlockType) {
        *out = EH_SPEC_BLOCK; return 0;
    }
    if (cls == (PyObject*)&gcc_HandlerType) {
        *out = HANDLER; return 0;
    }
    if (cls == (PyObject*)&gcc_MustNotThrowExprType) {
        *out = MUST_NOT_THROW_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_CleanupStmtType) {
        *out = CLEANUP_STMT; return 0;
    }
    if (cls == (PyObject*)&gcc_IfStmtType) {
        *out = IF_STMT; return 0;
    }
    if (cls == (PyObject*)&gcc_ForStmtType) {
        *out = FOR_STMT; return 0;
    }
    if (cls == (PyObject*)&gcc_RangeForStmtType) {
        *out = RANGE_FOR_STMT; return 0;
    }
    if (cls == (PyObject*)&gcc_WhileStmtType) {
        *out = WHILE_STMT; return 0;
    }
    if (cls == (PyObject*)&gcc_DoStmtType) {
        *out = DO_STMT; return 0;
    }
    if (cls == (PyObject*)&gcc_BreakStmtType) {
        *out = BREAK_STMT; return 0;
    }
    if (cls == (PyObject*)&gcc_ContinueStmtType) {
        *out = CONTINUE_STMT; return 0;
    }
    if (cls == (PyObject*)&gcc_SwitchStmtType) {
        *out = SWITCH_STMT; return 0;
    }
    if (cls == (PyObject*)&gcc_ExprStmtType) {
        *out = EXPR_STMT; return 0;
    }
    if (cls == (PyObject*)&gcc_TagDefnType) {
        *out = TAG_DEFN; return 0;
    }
    if (cls == (PyObject*)&gcc_OffsetofExprType) {
        *out = OFFSETOF_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_SizeofExprType) {
        *out = SIZEOF_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_ArrowExprType) {
        *out = ARROW_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_AlignofExprType) {
        *out = ALIGNOF_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_AtEncodeExprType) {
        *out = AT_ENCODE_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_StmtExprType) {
        *out = STMT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_UnaryPlusExprType) {
        *out = UNARY_PLUS_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_StaticAssertType) {
        *out = STATIC_ASSERT; return 0;
    }
    if (cls == (PyObject*)&gcc_TypeArgumentPackType) {
        *out = TYPE_ARGUMENT_PACK; return 0;
    }
    if (cls == (PyObject*)&gcc_NontypeArgumentPackType) {
        *out = NONTYPE_ARGUMENT_PACK; return 0;
    }
    if (cls == (PyObject*)&gcc_TypePackExpansionType) {
        *out = TYPE_PACK_EXPANSION; return 0;
    }
    if (cls == (PyObject*)&gcc_ExprPackExpansionType) {
        *out = EXPR_PACK_EXPANSION; return 0;
    }
    if (cls == (PyObject*)&gcc_ArgumentPackSelectType) {
        *out = ARGUMENT_PACK_SELECT; return 0;
    }
    if (cls == (PyObject*)&gcc_TraitExprType) {
        *out = TRAIT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_LambdaExprType) {
        *out = LAMBDA_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_DecltypeTypeType) {
        *out = DECLTYPE_TYPE; return 0;
    }
    if (cls == (PyObject*)&gcc_UnderlyingTypeType) {
        *out = UNDERLYING_TYPE; return 0;
    }
    if (cls == (PyObject*)&gcc_BasesType) {
        *out = BASES; return 0;
    }
    if (cls == (PyObject*)&gcc_TemplateInfoType) {
        *out = TEMPLATE_INFO; return 0;
    }
    if (cls == (PyObject*)&gcc_UrshiftExprType) {
        *out = URSHIFT_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_CompareExprType) {
        *out = COMPARE_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_CompareLExprType) {
        *out = COMPARE_L_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_CompareGExprType) {
        *out = COMPARE_G_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_ClassInterfaceTypeType) {
        *out = CLASS_INTERFACE_TYPE; return 0;
    }
    if (cls == (PyObject*)&gcc_ClassImplementationTypeType) {
        *out = CLASS_IMPLEMENTATION_TYPE; return 0;
    }
    if (cls == (PyObject*)&gcc_CategoryInterfaceTypeType) {
        *out = CATEGORY_INTERFACE_TYPE; return 0;
    }
    if (cls == (PyObject*)&gcc_CategoryImplementationTypeType) {
        *out = CATEGORY_IMPLEMENTATION_TYPE; return 0;
    }
    if (cls == (PyObject*)&gcc_ProtocolInterfaceTypeType) {
        *out = PROTOCOL_INTERFACE_TYPE; return 0;
    }
    if (cls == (PyObject*)&gcc_KeywordDeclType) {
        *out = KEYWORD_DECL; return 0;
    }
    if (cls == (PyObject*)&gcc_InstanceMethodDeclType) {
        *out = INSTANCE_METHOD_DECL; return 0;
    }
    if (cls == (PyObject*)&gcc_ClassMethodDeclType) {
        *out = CLASS_METHOD_DECL; return 0;
    }
    if (cls == (PyObject*)&gcc_PropertyDeclType) {
        *out = PROPERTY_DECL; return 0;
    }
    if (cls == (PyObject*)&gcc_MessageSendExprType) {
        *out = MESSAGE_SEND_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_ClassReferenceExprType) {
        *out = CLASS_REFERENCE_EXPR; return 0;
    }
    if (cls == (PyObject*)&gcc_PropertyRefType) {
        *out = PROPERTY_REF; return 0;
    }
    return -1;
}

PyGccWrapperTypeObject*
gcc_python_autogenerated_tree_type_for_tree_code(enum tree_code code, int borrow_ref)
{
    PyGccWrapperTypeObject *result;

    assert(code >= 0);
    assert(code < MAX_TREE_CODES);

    result = pytype_for_tree_code[code];

    if (!borrow_ref) {
        Py_INCREF(result);
    }
    return result;
}

PyGccWrapperTypeObject*
gcc_python_autogenerated_tree_type_for_tree(tree t, int borrow_ref)
{
    enum tree_code code = TREE_CODE(t);
    /* printf("code:%i\n", code); */
    return gcc_python_autogenerated_tree_type_for_tree_code(code, borrow_ref);
}

int autogenerated_tree_init_types(void)
{
    if (PyType_Ready((PyTypeObject*)&gcc_TreeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_StatementType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_UnaryType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_BinaryType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ConstantType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_VlExpType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ComparisonType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_DeclarationType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ExpressionType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ReferenceType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TypeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ErrorMarkType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_IdentifierNodeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TreeListType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TreeVecType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_BlockType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_OffsetTypeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_EnumeralTypeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_BooleanTypeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_IntegerTypeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_RealTypeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_PointerTypeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ReferenceTypeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_NullptrTypeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_FixedPointTypeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ComplexTypeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_VectorTypeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ArrayTypeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_RecordTypeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_UnionTypeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_QualUnionTypeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_VoidTypeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_FunctionTypeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_MethodTypeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_LangTypeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_IntegerCstType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_RealCstType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_FixedCstType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ComplexCstType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_VectorCstType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_StringCstType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_FunctionDeclType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_LabelDeclType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_FieldDeclType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_VarDeclType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ConstDeclType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ParmDeclType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TypeDeclType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ResultDeclType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_DebugExprDeclType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_NamespaceDeclType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ImportedDeclType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TranslationUnitDeclType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ComponentRefType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_BitFieldRefType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_RealpartExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ImagpartExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ArrayRefType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ArrayRangeRefType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_IndirectRefType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ObjTypeRefType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ConstructorType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_CompoundExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ModifyExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_InitExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TargetExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_CondExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_VecCondExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_VecPermExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_BindExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_CallExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_WithCleanupExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_CleanupPointExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_PlaceholderExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_PlusExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_MinusExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_MultExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_PointerPlusExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TruncDivExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_CeilDivExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_FloorDivExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_RoundDivExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TruncModExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_CeilModExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_FloorModExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_RoundModExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_RdivExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ExactDivExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_FixTruncExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_FloatExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_NegateExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_MinExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_MaxExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_AbsExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_LshiftExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_RshiftExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_LrotateExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_RrotateExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_BitIorExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_BitXorExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_BitAndExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_BitNotExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TruthAndifExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TruthOrifExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TruthAndExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TruthOrExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TruthXorExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TruthNotExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_LtExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_LeExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_GtExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_GeExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_EqExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_NeExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_UnorderedExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_OrderedExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_UnltExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_UnleExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_UngtExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_UngeExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_UneqExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_LtgtExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_RangeExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ParenExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ConvertExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_AddrSpaceConvertExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_FixedConvertExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_NopExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_NonLvalueExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ViewConvertExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_CompoundLiteralExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_SaveExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_AddrExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_FdescExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ComplexExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ConjExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_PredecrementExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_PreincrementExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_PostdecrementExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_PostincrementExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_VaArgExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TryCatchExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TryFinallyType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_DeclExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_LabelExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_GotoExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ReturnExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ExitExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_LoopExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_SwitchExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_CaseLabelExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_AsmExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_SsaNameType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_CatchExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_EhFilterExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ScevKnownType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ScevNotKnownType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_PolynomialChrecType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_StatementListType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_AssertExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TreeBinfoType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_WithSizeExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_RealignLoadType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TargetMemRefType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_MemRefType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_OmpParallelType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_OmpTaskType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_OmpForType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_OmpSectionsType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_OmpSingleType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_OmpSectionType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_OmpMasterType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_OmpOrderedType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_OmpCriticalType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_OmpAtomicType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_OmpAtomicReadType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_OmpAtomicCaptureOldType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_OmpAtomicCaptureNewType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_OmpClauseType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TransactionExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ReducMaxExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ReducMinExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ReducPlusExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_DotProdExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_WidenSumExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_WidenMultExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_WidenMultPlusExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_WidenMultMinusExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_WidenLshiftExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_FmaExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_VecLshiftExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_VecRshiftExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_WidenMultHiExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_WidenMultLoExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_VecUnpackHiExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_VecUnpackLoExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_VecUnpackFloatHiExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_VecUnpackFloatLoExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_VecPackTruncExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_VecPackSatExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_VecPackFixTruncExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_WidenLshiftHiExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_WidenLshiftLoExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_PredictExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_OptimizationNodeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TargetOptionNodeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_CMaybeConstExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ExcessPrecisionExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_UserdefLiteralType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_UnconstrainedArrayTypeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_UnconstrainedArrayRefType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_NullExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_PlusNomodExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_MinusNomodExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_AttrAddrExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_StmtStmtType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_LoopStmtType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ExitStmtType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_OffsetRefType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_PtrmemCstType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_NwExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_VecNwExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_DlExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_VecDlExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ScopeRefType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_MemberRefType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TypeExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_AggrInitExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_VecInitExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ThrowExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_EmptyClassExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_BaselinkType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TemplateDeclType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TemplateParmIndexType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TemplateTemplateParmType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TemplateTypeParmType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TypenameTypeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TypeofTypeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_BoundTemplateTemplateParmType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_UnboundClassTemplateType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_UsingDeclType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_UsingStmtType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_DefaultArgType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_DeferredNoexceptType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TemplateIdExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_OverloadType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_PseudoDtorExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ModopExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_CastExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ReinterpretCastExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ConstCastExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_StaticCastExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_DynamicCastExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ImplicitConvExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_DotstarExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TypeidExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_NoexceptExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_NonDependentExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_CtorInitializerType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TryBlockType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_EhSpecBlockType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_HandlerType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_MustNotThrowExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_CleanupStmtType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_IfStmtType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ForStmtType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_RangeForStmtType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_WhileStmtType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_DoStmtType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_BreakStmtType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ContinueStmtType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_SwitchStmtType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ExprStmtType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TagDefnType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_OffsetofExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_SizeofExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ArrowExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_AlignofExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_AtEncodeExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_StmtExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_UnaryPlusExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_StaticAssertType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TypeArgumentPackType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_NontypeArgumentPackType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TypePackExpansionType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ExprPackExpansionType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ArgumentPackSelectType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TraitExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_LambdaExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_DecltypeTypeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_UnderlyingTypeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_BasesType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_TemplateInfoType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_UrshiftExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_CompareExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_CompareLExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_CompareGExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ClassInterfaceTypeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ClassImplementationTypeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_CategoryInterfaceTypeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_CategoryImplementationTypeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ProtocolInterfaceTypeType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_KeywordDeclType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_InstanceMethodDeclType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ClassMethodDeclType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_PropertyDeclType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_MessageSendExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_ClassReferenceExprType) < 0)
        goto error;

    if (PyType_Ready((PyTypeObject*)&gcc_PropertyRefType) < 0)
        goto error;


    return 1;

error:
    return 0;
}

void autogenerated_tree_add_types(PyObject *m)
{
    Py_INCREF(&gcc_TreeType);
    PyModule_AddObject(m, "Tree", (PyObject *)&gcc_TreeType);

    Py_INCREF(&gcc_StatementType);
    PyModule_AddObject(m, "Statement", (PyObject *)&gcc_StatementType);

    Py_INCREF(&gcc_UnaryType);
    PyModule_AddObject(m, "Unary", (PyObject *)&gcc_UnaryType);

    Py_INCREF(&gcc_BinaryType);
    PyModule_AddObject(m, "Binary", (PyObject *)&gcc_BinaryType);

    Py_INCREF(&gcc_ConstantType);
    PyModule_AddObject(m, "Constant", (PyObject *)&gcc_ConstantType);

    Py_INCREF(&gcc_VlExpType);
    PyModule_AddObject(m, "VlExp", (PyObject *)&gcc_VlExpType);

    Py_INCREF(&gcc_ComparisonType);
    PyModule_AddObject(m, "Comparison", (PyObject *)&gcc_ComparisonType);

    Py_INCREF(&gcc_DeclarationType);
    PyModule_AddObject(m, "Declaration", (PyObject *)&gcc_DeclarationType);

    Py_INCREF(&gcc_ExpressionType);
    PyModule_AddObject(m, "Expression", (PyObject *)&gcc_ExpressionType);

    Py_INCREF(&gcc_ReferenceType);
    PyModule_AddObject(m, "Reference", (PyObject *)&gcc_ReferenceType);

    Py_INCREF(&gcc_TypeType);
    PyModule_AddObject(m, "Type", (PyObject *)&gcc_TypeType);

    Py_INCREF(&gcc_ErrorMarkType);
    PyModule_AddObject(m, "ErrorMark", (PyObject *)&gcc_ErrorMarkType);

    Py_INCREF(&gcc_IdentifierNodeType);
    PyModule_AddObject(m, "IdentifierNode", (PyObject *)&gcc_IdentifierNodeType);

    Py_INCREF(&gcc_TreeListType);
    PyModule_AddObject(m, "TreeList", (PyObject *)&gcc_TreeListType);

    Py_INCREF(&gcc_TreeVecType);
    PyModule_AddObject(m, "TreeVec", (PyObject *)&gcc_TreeVecType);

    Py_INCREF(&gcc_BlockType);
    PyModule_AddObject(m, "Block", (PyObject *)&gcc_BlockType);

    Py_INCREF(&gcc_OffsetTypeType);
    PyModule_AddObject(m, "OffsetType", (PyObject *)&gcc_OffsetTypeType);

    Py_INCREF(&gcc_EnumeralTypeType);
    PyModule_AddObject(m, "EnumeralType", (PyObject *)&gcc_EnumeralTypeType);

    Py_INCREF(&gcc_BooleanTypeType);
    PyModule_AddObject(m, "BooleanType", (PyObject *)&gcc_BooleanTypeType);

    Py_INCREF(&gcc_IntegerTypeType);
    PyModule_AddObject(m, "IntegerType", (PyObject *)&gcc_IntegerTypeType);

    Py_INCREF(&gcc_RealTypeType);
    PyModule_AddObject(m, "RealType", (PyObject *)&gcc_RealTypeType);

    Py_INCREF(&gcc_PointerTypeType);
    PyModule_AddObject(m, "PointerType", (PyObject *)&gcc_PointerTypeType);

    Py_INCREF(&gcc_ReferenceTypeType);
    PyModule_AddObject(m, "ReferenceType", (PyObject *)&gcc_ReferenceTypeType);

    Py_INCREF(&gcc_NullptrTypeType);
    PyModule_AddObject(m, "NullptrType", (PyObject *)&gcc_NullptrTypeType);

    Py_INCREF(&gcc_FixedPointTypeType);
    PyModule_AddObject(m, "FixedPointType", (PyObject *)&gcc_FixedPointTypeType);

    Py_INCREF(&gcc_ComplexTypeType);
    PyModule_AddObject(m, "ComplexType", (PyObject *)&gcc_ComplexTypeType);

    Py_INCREF(&gcc_VectorTypeType);
    PyModule_AddObject(m, "VectorType", (PyObject *)&gcc_VectorTypeType);

    Py_INCREF(&gcc_ArrayTypeType);
    PyModule_AddObject(m, "ArrayType", (PyObject *)&gcc_ArrayTypeType);

    Py_INCREF(&gcc_RecordTypeType);
    PyModule_AddObject(m, "RecordType", (PyObject *)&gcc_RecordTypeType);

    Py_INCREF(&gcc_UnionTypeType);
    PyModule_AddObject(m, "UnionType", (PyObject *)&gcc_UnionTypeType);

    Py_INCREF(&gcc_QualUnionTypeType);
    PyModule_AddObject(m, "QualUnionType", (PyObject *)&gcc_QualUnionTypeType);

    Py_INCREF(&gcc_VoidTypeType);
    PyModule_AddObject(m, "VoidType", (PyObject *)&gcc_VoidTypeType);

    Py_INCREF(&gcc_FunctionTypeType);
    PyModule_AddObject(m, "FunctionType", (PyObject *)&gcc_FunctionTypeType);

    Py_INCREF(&gcc_MethodTypeType);
    PyModule_AddObject(m, "MethodType", (PyObject *)&gcc_MethodTypeType);

    Py_INCREF(&gcc_LangTypeType);
    PyModule_AddObject(m, "LangType", (PyObject *)&gcc_LangTypeType);

    Py_INCREF(&gcc_IntegerCstType);
    PyModule_AddObject(m, "IntegerCst", (PyObject *)&gcc_IntegerCstType);

    Py_INCREF(&gcc_RealCstType);
    PyModule_AddObject(m, "RealCst", (PyObject *)&gcc_RealCstType);

    Py_INCREF(&gcc_FixedCstType);
    PyModule_AddObject(m, "FixedCst", (PyObject *)&gcc_FixedCstType);

    Py_INCREF(&gcc_ComplexCstType);
    PyModule_AddObject(m, "ComplexCst", (PyObject *)&gcc_ComplexCstType);

    Py_INCREF(&gcc_VectorCstType);
    PyModule_AddObject(m, "VectorCst", (PyObject *)&gcc_VectorCstType);

    Py_INCREF(&gcc_StringCstType);
    PyModule_AddObject(m, "StringCst", (PyObject *)&gcc_StringCstType);

    Py_INCREF(&gcc_FunctionDeclType);
    PyModule_AddObject(m, "FunctionDecl", (PyObject *)&gcc_FunctionDeclType);

    Py_INCREF(&gcc_LabelDeclType);
    PyModule_AddObject(m, "LabelDecl", (PyObject *)&gcc_LabelDeclType);

    Py_INCREF(&gcc_FieldDeclType);
    PyModule_AddObject(m, "FieldDecl", (PyObject *)&gcc_FieldDeclType);

    Py_INCREF(&gcc_VarDeclType);
    PyModule_AddObject(m, "VarDecl", (PyObject *)&gcc_VarDeclType);

    Py_INCREF(&gcc_ConstDeclType);
    PyModule_AddObject(m, "ConstDecl", (PyObject *)&gcc_ConstDeclType);

    Py_INCREF(&gcc_ParmDeclType);
    PyModule_AddObject(m, "ParmDecl", (PyObject *)&gcc_ParmDeclType);

    Py_INCREF(&gcc_TypeDeclType);
    PyModule_AddObject(m, "TypeDecl", (PyObject *)&gcc_TypeDeclType);

    Py_INCREF(&gcc_ResultDeclType);
    PyModule_AddObject(m, "ResultDecl", (PyObject *)&gcc_ResultDeclType);

    Py_INCREF(&gcc_DebugExprDeclType);
    PyModule_AddObject(m, "DebugExprDecl", (PyObject *)&gcc_DebugExprDeclType);

    Py_INCREF(&gcc_NamespaceDeclType);
    PyModule_AddObject(m, "NamespaceDecl", (PyObject *)&gcc_NamespaceDeclType);

    Py_INCREF(&gcc_ImportedDeclType);
    PyModule_AddObject(m, "ImportedDecl", (PyObject *)&gcc_ImportedDeclType);

    Py_INCREF(&gcc_TranslationUnitDeclType);
    PyModule_AddObject(m, "TranslationUnitDecl", (PyObject *)&gcc_TranslationUnitDeclType);

    Py_INCREF(&gcc_ComponentRefType);
    PyModule_AddObject(m, "ComponentRef", (PyObject *)&gcc_ComponentRefType);

    Py_INCREF(&gcc_BitFieldRefType);
    PyModule_AddObject(m, "BitFieldRef", (PyObject *)&gcc_BitFieldRefType);

    Py_INCREF(&gcc_RealpartExprType);
    PyModule_AddObject(m, "RealpartExpr", (PyObject *)&gcc_RealpartExprType);

    Py_INCREF(&gcc_ImagpartExprType);
    PyModule_AddObject(m, "ImagpartExpr", (PyObject *)&gcc_ImagpartExprType);

    Py_INCREF(&gcc_ArrayRefType);
    PyModule_AddObject(m, "ArrayRef", (PyObject *)&gcc_ArrayRefType);

    Py_INCREF(&gcc_ArrayRangeRefType);
    PyModule_AddObject(m, "ArrayRangeRef", (PyObject *)&gcc_ArrayRangeRefType);

    Py_INCREF(&gcc_IndirectRefType);
    PyModule_AddObject(m, "IndirectRef", (PyObject *)&gcc_IndirectRefType);

    Py_INCREF(&gcc_ObjTypeRefType);
    PyModule_AddObject(m, "ObjTypeRef", (PyObject *)&gcc_ObjTypeRefType);

    Py_INCREF(&gcc_ConstructorType);
    PyModule_AddObject(m, "Constructor", (PyObject *)&gcc_ConstructorType);

    Py_INCREF(&gcc_CompoundExprType);
    PyModule_AddObject(m, "CompoundExpr", (PyObject *)&gcc_CompoundExprType);

    Py_INCREF(&gcc_ModifyExprType);
    PyModule_AddObject(m, "ModifyExpr", (PyObject *)&gcc_ModifyExprType);

    Py_INCREF(&gcc_InitExprType);
    PyModule_AddObject(m, "InitExpr", (PyObject *)&gcc_InitExprType);

    Py_INCREF(&gcc_TargetExprType);
    PyModule_AddObject(m, "TargetExpr", (PyObject *)&gcc_TargetExprType);

    Py_INCREF(&gcc_CondExprType);
    PyModule_AddObject(m, "CondExpr", (PyObject *)&gcc_CondExprType);

    Py_INCREF(&gcc_VecCondExprType);
    PyModule_AddObject(m, "VecCondExpr", (PyObject *)&gcc_VecCondExprType);

    Py_INCREF(&gcc_VecPermExprType);
    PyModule_AddObject(m, "VecPermExpr", (PyObject *)&gcc_VecPermExprType);

    Py_INCREF(&gcc_BindExprType);
    PyModule_AddObject(m, "BindExpr", (PyObject *)&gcc_BindExprType);

    Py_INCREF(&gcc_CallExprType);
    PyModule_AddObject(m, "CallExpr", (PyObject *)&gcc_CallExprType);

    Py_INCREF(&gcc_WithCleanupExprType);
    PyModule_AddObject(m, "WithCleanupExpr", (PyObject *)&gcc_WithCleanupExprType);

    Py_INCREF(&gcc_CleanupPointExprType);
    PyModule_AddObject(m, "CleanupPointExpr", (PyObject *)&gcc_CleanupPointExprType);

    Py_INCREF(&gcc_PlaceholderExprType);
    PyModule_AddObject(m, "PlaceholderExpr", (PyObject *)&gcc_PlaceholderExprType);

    Py_INCREF(&gcc_PlusExprType);
    PyModule_AddObject(m, "PlusExpr", (PyObject *)&gcc_PlusExprType);

    Py_INCREF(&gcc_MinusExprType);
    PyModule_AddObject(m, "MinusExpr", (PyObject *)&gcc_MinusExprType);

    Py_INCREF(&gcc_MultExprType);
    PyModule_AddObject(m, "MultExpr", (PyObject *)&gcc_MultExprType);

    Py_INCREF(&gcc_PointerPlusExprType);
    PyModule_AddObject(m, "PointerPlusExpr", (PyObject *)&gcc_PointerPlusExprType);

    Py_INCREF(&gcc_TruncDivExprType);
    PyModule_AddObject(m, "TruncDivExpr", (PyObject *)&gcc_TruncDivExprType);

    Py_INCREF(&gcc_CeilDivExprType);
    PyModule_AddObject(m, "CeilDivExpr", (PyObject *)&gcc_CeilDivExprType);

    Py_INCREF(&gcc_FloorDivExprType);
    PyModule_AddObject(m, "FloorDivExpr", (PyObject *)&gcc_FloorDivExprType);

    Py_INCREF(&gcc_RoundDivExprType);
    PyModule_AddObject(m, "RoundDivExpr", (PyObject *)&gcc_RoundDivExprType);

    Py_INCREF(&gcc_TruncModExprType);
    PyModule_AddObject(m, "TruncModExpr", (PyObject *)&gcc_TruncModExprType);

    Py_INCREF(&gcc_CeilModExprType);
    PyModule_AddObject(m, "CeilModExpr", (PyObject *)&gcc_CeilModExprType);

    Py_INCREF(&gcc_FloorModExprType);
    PyModule_AddObject(m, "FloorModExpr", (PyObject *)&gcc_FloorModExprType);

    Py_INCREF(&gcc_RoundModExprType);
    PyModule_AddObject(m, "RoundModExpr", (PyObject *)&gcc_RoundModExprType);

    Py_INCREF(&gcc_RdivExprType);
    PyModule_AddObject(m, "RdivExpr", (PyObject *)&gcc_RdivExprType);

    Py_INCREF(&gcc_ExactDivExprType);
    PyModule_AddObject(m, "ExactDivExpr", (PyObject *)&gcc_ExactDivExprType);

    Py_INCREF(&gcc_FixTruncExprType);
    PyModule_AddObject(m, "FixTruncExpr", (PyObject *)&gcc_FixTruncExprType);

    Py_INCREF(&gcc_FloatExprType);
    PyModule_AddObject(m, "FloatExpr", (PyObject *)&gcc_FloatExprType);

    Py_INCREF(&gcc_NegateExprType);
    PyModule_AddObject(m, "NegateExpr", (PyObject *)&gcc_NegateExprType);

    Py_INCREF(&gcc_MinExprType);
    PyModule_AddObject(m, "MinExpr", (PyObject *)&gcc_MinExprType);

    Py_INCREF(&gcc_MaxExprType);
    PyModule_AddObject(m, "MaxExpr", (PyObject *)&gcc_MaxExprType);

    Py_INCREF(&gcc_AbsExprType);
    PyModule_AddObject(m, "AbsExpr", (PyObject *)&gcc_AbsExprType);

    Py_INCREF(&gcc_LshiftExprType);
    PyModule_AddObject(m, "LshiftExpr", (PyObject *)&gcc_LshiftExprType);

    Py_INCREF(&gcc_RshiftExprType);
    PyModule_AddObject(m, "RshiftExpr", (PyObject *)&gcc_RshiftExprType);

    Py_INCREF(&gcc_LrotateExprType);
    PyModule_AddObject(m, "LrotateExpr", (PyObject *)&gcc_LrotateExprType);

    Py_INCREF(&gcc_RrotateExprType);
    PyModule_AddObject(m, "RrotateExpr", (PyObject *)&gcc_RrotateExprType);

    Py_INCREF(&gcc_BitIorExprType);
    PyModule_AddObject(m, "BitIorExpr", (PyObject *)&gcc_BitIorExprType);

    Py_INCREF(&gcc_BitXorExprType);
    PyModule_AddObject(m, "BitXorExpr", (PyObject *)&gcc_BitXorExprType);

    Py_INCREF(&gcc_BitAndExprType);
    PyModule_AddObject(m, "BitAndExpr", (PyObject *)&gcc_BitAndExprType);

    Py_INCREF(&gcc_BitNotExprType);
    PyModule_AddObject(m, "BitNotExpr", (PyObject *)&gcc_BitNotExprType);

    Py_INCREF(&gcc_TruthAndifExprType);
    PyModule_AddObject(m, "TruthAndifExpr", (PyObject *)&gcc_TruthAndifExprType);

    Py_INCREF(&gcc_TruthOrifExprType);
    PyModule_AddObject(m, "TruthOrifExpr", (PyObject *)&gcc_TruthOrifExprType);

    Py_INCREF(&gcc_TruthAndExprType);
    PyModule_AddObject(m, "TruthAndExpr", (PyObject *)&gcc_TruthAndExprType);

    Py_INCREF(&gcc_TruthOrExprType);
    PyModule_AddObject(m, "TruthOrExpr", (PyObject *)&gcc_TruthOrExprType);

    Py_INCREF(&gcc_TruthXorExprType);
    PyModule_AddObject(m, "TruthXorExpr", (PyObject *)&gcc_TruthXorExprType);

    Py_INCREF(&gcc_TruthNotExprType);
    PyModule_AddObject(m, "TruthNotExpr", (PyObject *)&gcc_TruthNotExprType);

    Py_INCREF(&gcc_LtExprType);
    PyModule_AddObject(m, "LtExpr", (PyObject *)&gcc_LtExprType);

    Py_INCREF(&gcc_LeExprType);
    PyModule_AddObject(m, "LeExpr", (PyObject *)&gcc_LeExprType);

    Py_INCREF(&gcc_GtExprType);
    PyModule_AddObject(m, "GtExpr", (PyObject *)&gcc_GtExprType);

    Py_INCREF(&gcc_GeExprType);
    PyModule_AddObject(m, "GeExpr", (PyObject *)&gcc_GeExprType);

    Py_INCREF(&gcc_EqExprType);
    PyModule_AddObject(m, "EqExpr", (PyObject *)&gcc_EqExprType);

    Py_INCREF(&gcc_NeExprType);
    PyModule_AddObject(m, "NeExpr", (PyObject *)&gcc_NeExprType);

    Py_INCREF(&gcc_UnorderedExprType);
    PyModule_AddObject(m, "UnorderedExpr", (PyObject *)&gcc_UnorderedExprType);

    Py_INCREF(&gcc_OrderedExprType);
    PyModule_AddObject(m, "OrderedExpr", (PyObject *)&gcc_OrderedExprType);

    Py_INCREF(&gcc_UnltExprType);
    PyModule_AddObject(m, "UnltExpr", (PyObject *)&gcc_UnltExprType);

    Py_INCREF(&gcc_UnleExprType);
    PyModule_AddObject(m, "UnleExpr", (PyObject *)&gcc_UnleExprType);

    Py_INCREF(&gcc_UngtExprType);
    PyModule_AddObject(m, "UngtExpr", (PyObject *)&gcc_UngtExprType);

    Py_INCREF(&gcc_UngeExprType);
    PyModule_AddObject(m, "UngeExpr", (PyObject *)&gcc_UngeExprType);

    Py_INCREF(&gcc_UneqExprType);
    PyModule_AddObject(m, "UneqExpr", (PyObject *)&gcc_UneqExprType);

    Py_INCREF(&gcc_LtgtExprType);
    PyModule_AddObject(m, "LtgtExpr", (PyObject *)&gcc_LtgtExprType);

    Py_INCREF(&gcc_RangeExprType);
    PyModule_AddObject(m, "RangeExpr", (PyObject *)&gcc_RangeExprType);

    Py_INCREF(&gcc_ParenExprType);
    PyModule_AddObject(m, "ParenExpr", (PyObject *)&gcc_ParenExprType);

    Py_INCREF(&gcc_ConvertExprType);
    PyModule_AddObject(m, "ConvertExpr", (PyObject *)&gcc_ConvertExprType);

    Py_INCREF(&gcc_AddrSpaceConvertExprType);
    PyModule_AddObject(m, "AddrSpaceConvertExpr", (PyObject *)&gcc_AddrSpaceConvertExprType);

    Py_INCREF(&gcc_FixedConvertExprType);
    PyModule_AddObject(m, "FixedConvertExpr", (PyObject *)&gcc_FixedConvertExprType);

    Py_INCREF(&gcc_NopExprType);
    PyModule_AddObject(m, "NopExpr", (PyObject *)&gcc_NopExprType);

    Py_INCREF(&gcc_NonLvalueExprType);
    PyModule_AddObject(m, "NonLvalueExpr", (PyObject *)&gcc_NonLvalueExprType);

    Py_INCREF(&gcc_ViewConvertExprType);
    PyModule_AddObject(m, "ViewConvertExpr", (PyObject *)&gcc_ViewConvertExprType);

    Py_INCREF(&gcc_CompoundLiteralExprType);
    PyModule_AddObject(m, "CompoundLiteralExpr", (PyObject *)&gcc_CompoundLiteralExprType);

    Py_INCREF(&gcc_SaveExprType);
    PyModule_AddObject(m, "SaveExpr", (PyObject *)&gcc_SaveExprType);

    Py_INCREF(&gcc_AddrExprType);
    PyModule_AddObject(m, "AddrExpr", (PyObject *)&gcc_AddrExprType);

    Py_INCREF(&gcc_FdescExprType);
    PyModule_AddObject(m, "FdescExpr", (PyObject *)&gcc_FdescExprType);

    Py_INCREF(&gcc_ComplexExprType);
    PyModule_AddObject(m, "ComplexExpr", (PyObject *)&gcc_ComplexExprType);

    Py_INCREF(&gcc_ConjExprType);
    PyModule_AddObject(m, "ConjExpr", (PyObject *)&gcc_ConjExprType);

    Py_INCREF(&gcc_PredecrementExprType);
    PyModule_AddObject(m, "PredecrementExpr", (PyObject *)&gcc_PredecrementExprType);

    Py_INCREF(&gcc_PreincrementExprType);
    PyModule_AddObject(m, "PreincrementExpr", (PyObject *)&gcc_PreincrementExprType);

    Py_INCREF(&gcc_PostdecrementExprType);
    PyModule_AddObject(m, "PostdecrementExpr", (PyObject *)&gcc_PostdecrementExprType);

    Py_INCREF(&gcc_PostincrementExprType);
    PyModule_AddObject(m, "PostincrementExpr", (PyObject *)&gcc_PostincrementExprType);

    Py_INCREF(&gcc_VaArgExprType);
    PyModule_AddObject(m, "VaArgExpr", (PyObject *)&gcc_VaArgExprType);

    Py_INCREF(&gcc_TryCatchExprType);
    PyModule_AddObject(m, "TryCatchExpr", (PyObject *)&gcc_TryCatchExprType);

    Py_INCREF(&gcc_TryFinallyType);
    PyModule_AddObject(m, "TryFinally", (PyObject *)&gcc_TryFinallyType);

    Py_INCREF(&gcc_DeclExprType);
    PyModule_AddObject(m, "DeclExpr", (PyObject *)&gcc_DeclExprType);

    Py_INCREF(&gcc_LabelExprType);
    PyModule_AddObject(m, "LabelExpr", (PyObject *)&gcc_LabelExprType);

    Py_INCREF(&gcc_GotoExprType);
    PyModule_AddObject(m, "GotoExpr", (PyObject *)&gcc_GotoExprType);

    Py_INCREF(&gcc_ReturnExprType);
    PyModule_AddObject(m, "ReturnExpr", (PyObject *)&gcc_ReturnExprType);

    Py_INCREF(&gcc_ExitExprType);
    PyModule_AddObject(m, "ExitExpr", (PyObject *)&gcc_ExitExprType);

    Py_INCREF(&gcc_LoopExprType);
    PyModule_AddObject(m, "LoopExpr", (PyObject *)&gcc_LoopExprType);

    Py_INCREF(&gcc_SwitchExprType);
    PyModule_AddObject(m, "SwitchExpr", (PyObject *)&gcc_SwitchExprType);

    Py_INCREF(&gcc_CaseLabelExprType);
    PyModule_AddObject(m, "CaseLabelExpr", (PyObject *)&gcc_CaseLabelExprType);

    Py_INCREF(&gcc_AsmExprType);
    PyModule_AddObject(m, "AsmExpr", (PyObject *)&gcc_AsmExprType);

    Py_INCREF(&gcc_SsaNameType);
    PyModule_AddObject(m, "SsaName", (PyObject *)&gcc_SsaNameType);

    Py_INCREF(&gcc_CatchExprType);
    PyModule_AddObject(m, "CatchExpr", (PyObject *)&gcc_CatchExprType);

    Py_INCREF(&gcc_EhFilterExprType);
    PyModule_AddObject(m, "EhFilterExpr", (PyObject *)&gcc_EhFilterExprType);

    Py_INCREF(&gcc_ScevKnownType);
    PyModule_AddObject(m, "ScevKnown", (PyObject *)&gcc_ScevKnownType);

    Py_INCREF(&gcc_ScevNotKnownType);
    PyModule_AddObject(m, "ScevNotKnown", (PyObject *)&gcc_ScevNotKnownType);

    Py_INCREF(&gcc_PolynomialChrecType);
    PyModule_AddObject(m, "PolynomialChrec", (PyObject *)&gcc_PolynomialChrecType);

    Py_INCREF(&gcc_StatementListType);
    PyModule_AddObject(m, "StatementList", (PyObject *)&gcc_StatementListType);

    Py_INCREF(&gcc_AssertExprType);
    PyModule_AddObject(m, "AssertExpr", (PyObject *)&gcc_AssertExprType);

    Py_INCREF(&gcc_TreeBinfoType);
    PyModule_AddObject(m, "TreeBinfo", (PyObject *)&gcc_TreeBinfoType);

    Py_INCREF(&gcc_WithSizeExprType);
    PyModule_AddObject(m, "WithSizeExpr", (PyObject *)&gcc_WithSizeExprType);

    Py_INCREF(&gcc_RealignLoadType);
    PyModule_AddObject(m, "RealignLoad", (PyObject *)&gcc_RealignLoadType);

    Py_INCREF(&gcc_TargetMemRefType);
    PyModule_AddObject(m, "TargetMemRef", (PyObject *)&gcc_TargetMemRefType);

    Py_INCREF(&gcc_MemRefType);
    PyModule_AddObject(m, "MemRef", (PyObject *)&gcc_MemRefType);

    Py_INCREF(&gcc_OmpParallelType);
    PyModule_AddObject(m, "OmpParallel", (PyObject *)&gcc_OmpParallelType);

    Py_INCREF(&gcc_OmpTaskType);
    PyModule_AddObject(m, "OmpTask", (PyObject *)&gcc_OmpTaskType);

    Py_INCREF(&gcc_OmpForType);
    PyModule_AddObject(m, "OmpFor", (PyObject *)&gcc_OmpForType);

    Py_INCREF(&gcc_OmpSectionsType);
    PyModule_AddObject(m, "OmpSections", (PyObject *)&gcc_OmpSectionsType);

    Py_INCREF(&gcc_OmpSingleType);
    PyModule_AddObject(m, "OmpSingle", (PyObject *)&gcc_OmpSingleType);

    Py_INCREF(&gcc_OmpSectionType);
    PyModule_AddObject(m, "OmpSection", (PyObject *)&gcc_OmpSectionType);

    Py_INCREF(&gcc_OmpMasterType);
    PyModule_AddObject(m, "OmpMaster", (PyObject *)&gcc_OmpMasterType);

    Py_INCREF(&gcc_OmpOrderedType);
    PyModule_AddObject(m, "OmpOrdered", (PyObject *)&gcc_OmpOrderedType);

    Py_INCREF(&gcc_OmpCriticalType);
    PyModule_AddObject(m, "OmpCritical", (PyObject *)&gcc_OmpCriticalType);

    Py_INCREF(&gcc_OmpAtomicType);
    PyModule_AddObject(m, "OmpAtomic", (PyObject *)&gcc_OmpAtomicType);

    Py_INCREF(&gcc_OmpAtomicReadType);
    PyModule_AddObject(m, "OmpAtomicRead", (PyObject *)&gcc_OmpAtomicReadType);

    Py_INCREF(&gcc_OmpAtomicCaptureOldType);
    PyModule_AddObject(m, "OmpAtomicCaptureOld", (PyObject *)&gcc_OmpAtomicCaptureOldType);

    Py_INCREF(&gcc_OmpAtomicCaptureNewType);
    PyModule_AddObject(m, "OmpAtomicCaptureNew", (PyObject *)&gcc_OmpAtomicCaptureNewType);

    Py_INCREF(&gcc_OmpClauseType);
    PyModule_AddObject(m, "OmpClause", (PyObject *)&gcc_OmpClauseType);

    Py_INCREF(&gcc_TransactionExprType);
    PyModule_AddObject(m, "TransactionExpr", (PyObject *)&gcc_TransactionExprType);

    Py_INCREF(&gcc_ReducMaxExprType);
    PyModule_AddObject(m, "ReducMaxExpr", (PyObject *)&gcc_ReducMaxExprType);

    Py_INCREF(&gcc_ReducMinExprType);
    PyModule_AddObject(m, "ReducMinExpr", (PyObject *)&gcc_ReducMinExprType);

    Py_INCREF(&gcc_ReducPlusExprType);
    PyModule_AddObject(m, "ReducPlusExpr", (PyObject *)&gcc_ReducPlusExprType);

    Py_INCREF(&gcc_DotProdExprType);
    PyModule_AddObject(m, "DotProdExpr", (PyObject *)&gcc_DotProdExprType);

    Py_INCREF(&gcc_WidenSumExprType);
    PyModule_AddObject(m, "WidenSumExpr", (PyObject *)&gcc_WidenSumExprType);

    Py_INCREF(&gcc_WidenMultExprType);
    PyModule_AddObject(m, "WidenMultExpr", (PyObject *)&gcc_WidenMultExprType);

    Py_INCREF(&gcc_WidenMultPlusExprType);
    PyModule_AddObject(m, "WidenMultPlusExpr", (PyObject *)&gcc_WidenMultPlusExprType);

    Py_INCREF(&gcc_WidenMultMinusExprType);
    PyModule_AddObject(m, "WidenMultMinusExpr", (PyObject *)&gcc_WidenMultMinusExprType);

    Py_INCREF(&gcc_WidenLshiftExprType);
    PyModule_AddObject(m, "WidenLshiftExpr", (PyObject *)&gcc_WidenLshiftExprType);

    Py_INCREF(&gcc_FmaExprType);
    PyModule_AddObject(m, "FmaExpr", (PyObject *)&gcc_FmaExprType);

    Py_INCREF(&gcc_VecLshiftExprType);
    PyModule_AddObject(m, "VecLshiftExpr", (PyObject *)&gcc_VecLshiftExprType);

    Py_INCREF(&gcc_VecRshiftExprType);
    PyModule_AddObject(m, "VecRshiftExpr", (PyObject *)&gcc_VecRshiftExprType);

    Py_INCREF(&gcc_WidenMultHiExprType);
    PyModule_AddObject(m, "WidenMultHiExpr", (PyObject *)&gcc_WidenMultHiExprType);

    Py_INCREF(&gcc_WidenMultLoExprType);
    PyModule_AddObject(m, "WidenMultLoExpr", (PyObject *)&gcc_WidenMultLoExprType);

    Py_INCREF(&gcc_VecUnpackHiExprType);
    PyModule_AddObject(m, "VecUnpackHiExpr", (PyObject *)&gcc_VecUnpackHiExprType);

    Py_INCREF(&gcc_VecUnpackLoExprType);
    PyModule_AddObject(m, "VecUnpackLoExpr", (PyObject *)&gcc_VecUnpackLoExprType);

    Py_INCREF(&gcc_VecUnpackFloatHiExprType);
    PyModule_AddObject(m, "VecUnpackFloatHiExpr", (PyObject *)&gcc_VecUnpackFloatHiExprType);

    Py_INCREF(&gcc_VecUnpackFloatLoExprType);
    PyModule_AddObject(m, "VecUnpackFloatLoExpr", (PyObject *)&gcc_VecUnpackFloatLoExprType);

    Py_INCREF(&gcc_VecPackTruncExprType);
    PyModule_AddObject(m, "VecPackTruncExpr", (PyObject *)&gcc_VecPackTruncExprType);

    Py_INCREF(&gcc_VecPackSatExprType);
    PyModule_AddObject(m, "VecPackSatExpr", (PyObject *)&gcc_VecPackSatExprType);

    Py_INCREF(&gcc_VecPackFixTruncExprType);
    PyModule_AddObject(m, "VecPackFixTruncExpr", (PyObject *)&gcc_VecPackFixTruncExprType);

    Py_INCREF(&gcc_WidenLshiftHiExprType);
    PyModule_AddObject(m, "WidenLshiftHiExpr", (PyObject *)&gcc_WidenLshiftHiExprType);

    Py_INCREF(&gcc_WidenLshiftLoExprType);
    PyModule_AddObject(m, "WidenLshiftLoExpr", (PyObject *)&gcc_WidenLshiftLoExprType);

    Py_INCREF(&gcc_PredictExprType);
    PyModule_AddObject(m, "PredictExpr", (PyObject *)&gcc_PredictExprType);

    Py_INCREF(&gcc_OptimizationNodeType);
    PyModule_AddObject(m, "OptimizationNode", (PyObject *)&gcc_OptimizationNodeType);

    Py_INCREF(&gcc_TargetOptionNodeType);
    PyModule_AddObject(m, "TargetOptionNode", (PyObject *)&gcc_TargetOptionNodeType);

    Py_INCREF(&gcc_CMaybeConstExprType);
    PyModule_AddObject(m, "CMaybeConstExpr", (PyObject *)&gcc_CMaybeConstExprType);

    Py_INCREF(&gcc_ExcessPrecisionExprType);
    PyModule_AddObject(m, "ExcessPrecisionExpr", (PyObject *)&gcc_ExcessPrecisionExprType);

    Py_INCREF(&gcc_UserdefLiteralType);
    PyModule_AddObject(m, "UserdefLiteral", (PyObject *)&gcc_UserdefLiteralType);

    Py_INCREF(&gcc_UnconstrainedArrayTypeType);
    PyModule_AddObject(m, "UnconstrainedArrayType", (PyObject *)&gcc_UnconstrainedArrayTypeType);

    Py_INCREF(&gcc_UnconstrainedArrayRefType);
    PyModule_AddObject(m, "UnconstrainedArrayRef", (PyObject *)&gcc_UnconstrainedArrayRefType);

    Py_INCREF(&gcc_NullExprType);
    PyModule_AddObject(m, "NullExpr", (PyObject *)&gcc_NullExprType);

    Py_INCREF(&gcc_PlusNomodExprType);
    PyModule_AddObject(m, "PlusNomodExpr", (PyObject *)&gcc_PlusNomodExprType);

    Py_INCREF(&gcc_MinusNomodExprType);
    PyModule_AddObject(m, "MinusNomodExpr", (PyObject *)&gcc_MinusNomodExprType);

    Py_INCREF(&gcc_AttrAddrExprType);
    PyModule_AddObject(m, "AttrAddrExpr", (PyObject *)&gcc_AttrAddrExprType);

    Py_INCREF(&gcc_StmtStmtType);
    PyModule_AddObject(m, "StmtStmt", (PyObject *)&gcc_StmtStmtType);

    Py_INCREF(&gcc_LoopStmtType);
    PyModule_AddObject(m, "LoopStmt", (PyObject *)&gcc_LoopStmtType);

    Py_INCREF(&gcc_ExitStmtType);
    PyModule_AddObject(m, "ExitStmt", (PyObject *)&gcc_ExitStmtType);

    Py_INCREF(&gcc_OffsetRefType);
    PyModule_AddObject(m, "OffsetRef", (PyObject *)&gcc_OffsetRefType);

    Py_INCREF(&gcc_PtrmemCstType);
    PyModule_AddObject(m, "PtrmemCst", (PyObject *)&gcc_PtrmemCstType);

    Py_INCREF(&gcc_NwExprType);
    PyModule_AddObject(m, "NwExpr", (PyObject *)&gcc_NwExprType);

    Py_INCREF(&gcc_VecNwExprType);
    PyModule_AddObject(m, "VecNwExpr", (PyObject *)&gcc_VecNwExprType);

    Py_INCREF(&gcc_DlExprType);
    PyModule_AddObject(m, "DlExpr", (PyObject *)&gcc_DlExprType);

    Py_INCREF(&gcc_VecDlExprType);
    PyModule_AddObject(m, "VecDlExpr", (PyObject *)&gcc_VecDlExprType);

    Py_INCREF(&gcc_ScopeRefType);
    PyModule_AddObject(m, "ScopeRef", (PyObject *)&gcc_ScopeRefType);

    Py_INCREF(&gcc_MemberRefType);
    PyModule_AddObject(m, "MemberRef", (PyObject *)&gcc_MemberRefType);

    Py_INCREF(&gcc_TypeExprType);
    PyModule_AddObject(m, "TypeExpr", (PyObject *)&gcc_TypeExprType);

    Py_INCREF(&gcc_AggrInitExprType);
    PyModule_AddObject(m, "AggrInitExpr", (PyObject *)&gcc_AggrInitExprType);

    Py_INCREF(&gcc_VecInitExprType);
    PyModule_AddObject(m, "VecInitExpr", (PyObject *)&gcc_VecInitExprType);

    Py_INCREF(&gcc_ThrowExprType);
    PyModule_AddObject(m, "ThrowExpr", (PyObject *)&gcc_ThrowExprType);

    Py_INCREF(&gcc_EmptyClassExprType);
    PyModule_AddObject(m, "EmptyClassExpr", (PyObject *)&gcc_EmptyClassExprType);

    Py_INCREF(&gcc_BaselinkType);
    PyModule_AddObject(m, "Baselink", (PyObject *)&gcc_BaselinkType);

    Py_INCREF(&gcc_TemplateDeclType);
    PyModule_AddObject(m, "TemplateDecl", (PyObject *)&gcc_TemplateDeclType);

    Py_INCREF(&gcc_TemplateParmIndexType);
    PyModule_AddObject(m, "TemplateParmIndex", (PyObject *)&gcc_TemplateParmIndexType);

    Py_INCREF(&gcc_TemplateTemplateParmType);
    PyModule_AddObject(m, "TemplateTemplateParm", (PyObject *)&gcc_TemplateTemplateParmType);

    Py_INCREF(&gcc_TemplateTypeParmType);
    PyModule_AddObject(m, "TemplateTypeParm", (PyObject *)&gcc_TemplateTypeParmType);

    Py_INCREF(&gcc_TypenameTypeType);
    PyModule_AddObject(m, "TypenameType", (PyObject *)&gcc_TypenameTypeType);

    Py_INCREF(&gcc_TypeofTypeType);
    PyModule_AddObject(m, "TypeofType", (PyObject *)&gcc_TypeofTypeType);

    Py_INCREF(&gcc_BoundTemplateTemplateParmType);
    PyModule_AddObject(m, "BoundTemplateTemplateParm", (PyObject *)&gcc_BoundTemplateTemplateParmType);

    Py_INCREF(&gcc_UnboundClassTemplateType);
    PyModule_AddObject(m, "UnboundClassTemplate", (PyObject *)&gcc_UnboundClassTemplateType);

    Py_INCREF(&gcc_UsingDeclType);
    PyModule_AddObject(m, "UsingDecl", (PyObject *)&gcc_UsingDeclType);

    Py_INCREF(&gcc_UsingStmtType);
    PyModule_AddObject(m, "UsingStmt", (PyObject *)&gcc_UsingStmtType);

    Py_INCREF(&gcc_DefaultArgType);
    PyModule_AddObject(m, "DefaultArg", (PyObject *)&gcc_DefaultArgType);

    Py_INCREF(&gcc_DeferredNoexceptType);
    PyModule_AddObject(m, "DeferredNoexcept", (PyObject *)&gcc_DeferredNoexceptType);

    Py_INCREF(&gcc_TemplateIdExprType);
    PyModule_AddObject(m, "TemplateIdExpr", (PyObject *)&gcc_TemplateIdExprType);

    Py_INCREF(&gcc_OverloadType);
    PyModule_AddObject(m, "Overload", (PyObject *)&gcc_OverloadType);

    Py_INCREF(&gcc_PseudoDtorExprType);
    PyModule_AddObject(m, "PseudoDtorExpr", (PyObject *)&gcc_PseudoDtorExprType);

    Py_INCREF(&gcc_ModopExprType);
    PyModule_AddObject(m, "ModopExpr", (PyObject *)&gcc_ModopExprType);

    Py_INCREF(&gcc_CastExprType);
    PyModule_AddObject(m, "CastExpr", (PyObject *)&gcc_CastExprType);

    Py_INCREF(&gcc_ReinterpretCastExprType);
    PyModule_AddObject(m, "ReinterpretCastExpr", (PyObject *)&gcc_ReinterpretCastExprType);

    Py_INCREF(&gcc_ConstCastExprType);
    PyModule_AddObject(m, "ConstCastExpr", (PyObject *)&gcc_ConstCastExprType);

    Py_INCREF(&gcc_StaticCastExprType);
    PyModule_AddObject(m, "StaticCastExpr", (PyObject *)&gcc_StaticCastExprType);

    Py_INCREF(&gcc_DynamicCastExprType);
    PyModule_AddObject(m, "DynamicCastExpr", (PyObject *)&gcc_DynamicCastExprType);

    Py_INCREF(&gcc_ImplicitConvExprType);
    PyModule_AddObject(m, "ImplicitConvExpr", (PyObject *)&gcc_ImplicitConvExprType);

    Py_INCREF(&gcc_DotstarExprType);
    PyModule_AddObject(m, "DotstarExpr", (PyObject *)&gcc_DotstarExprType);

    Py_INCREF(&gcc_TypeidExprType);
    PyModule_AddObject(m, "TypeidExpr", (PyObject *)&gcc_TypeidExprType);

    Py_INCREF(&gcc_NoexceptExprType);
    PyModule_AddObject(m, "NoexceptExpr", (PyObject *)&gcc_NoexceptExprType);

    Py_INCREF(&gcc_NonDependentExprType);
    PyModule_AddObject(m, "NonDependentExpr", (PyObject *)&gcc_NonDependentExprType);

    Py_INCREF(&gcc_CtorInitializerType);
    PyModule_AddObject(m, "CtorInitializer", (PyObject *)&gcc_CtorInitializerType);

    Py_INCREF(&gcc_TryBlockType);
    PyModule_AddObject(m, "TryBlock", (PyObject *)&gcc_TryBlockType);

    Py_INCREF(&gcc_EhSpecBlockType);
    PyModule_AddObject(m, "EhSpecBlock", (PyObject *)&gcc_EhSpecBlockType);

    Py_INCREF(&gcc_HandlerType);
    PyModule_AddObject(m, "Handler", (PyObject *)&gcc_HandlerType);

    Py_INCREF(&gcc_MustNotThrowExprType);
    PyModule_AddObject(m, "MustNotThrowExpr", (PyObject *)&gcc_MustNotThrowExprType);

    Py_INCREF(&gcc_CleanupStmtType);
    PyModule_AddObject(m, "CleanupStmt", (PyObject *)&gcc_CleanupStmtType);

    Py_INCREF(&gcc_IfStmtType);
    PyModule_AddObject(m, "IfStmt", (PyObject *)&gcc_IfStmtType);

    Py_INCREF(&gcc_ForStmtType);
    PyModule_AddObject(m, "ForStmt", (PyObject *)&gcc_ForStmtType);

    Py_INCREF(&gcc_RangeForStmtType);
    PyModule_AddObject(m, "RangeForStmt", (PyObject *)&gcc_RangeForStmtType);

    Py_INCREF(&gcc_WhileStmtType);
    PyModule_AddObject(m, "WhileStmt", (PyObject *)&gcc_WhileStmtType);

    Py_INCREF(&gcc_DoStmtType);
    PyModule_AddObject(m, "DoStmt", (PyObject *)&gcc_DoStmtType);

    Py_INCREF(&gcc_BreakStmtType);
    PyModule_AddObject(m, "BreakStmt", (PyObject *)&gcc_BreakStmtType);

    Py_INCREF(&gcc_ContinueStmtType);
    PyModule_AddObject(m, "ContinueStmt", (PyObject *)&gcc_ContinueStmtType);

    Py_INCREF(&gcc_SwitchStmtType);
    PyModule_AddObject(m, "SwitchStmt", (PyObject *)&gcc_SwitchStmtType);

    Py_INCREF(&gcc_ExprStmtType);
    PyModule_AddObject(m, "ExprStmt", (PyObject *)&gcc_ExprStmtType);

    Py_INCREF(&gcc_TagDefnType);
    PyModule_AddObject(m, "TagDefn", (PyObject *)&gcc_TagDefnType);

    Py_INCREF(&gcc_OffsetofExprType);
    PyModule_AddObject(m, "OffsetofExpr", (PyObject *)&gcc_OffsetofExprType);

    Py_INCREF(&gcc_SizeofExprType);
    PyModule_AddObject(m, "SizeofExpr", (PyObject *)&gcc_SizeofExprType);

    Py_INCREF(&gcc_ArrowExprType);
    PyModule_AddObject(m, "ArrowExpr", (PyObject *)&gcc_ArrowExprType);

    Py_INCREF(&gcc_AlignofExprType);
    PyModule_AddObject(m, "AlignofExpr", (PyObject *)&gcc_AlignofExprType);

    Py_INCREF(&gcc_AtEncodeExprType);
    PyModule_AddObject(m, "AtEncodeExpr", (PyObject *)&gcc_AtEncodeExprType);

    Py_INCREF(&gcc_StmtExprType);
    PyModule_AddObject(m, "StmtExpr", (PyObject *)&gcc_StmtExprType);

    Py_INCREF(&gcc_UnaryPlusExprType);
    PyModule_AddObject(m, "UnaryPlusExpr", (PyObject *)&gcc_UnaryPlusExprType);

    Py_INCREF(&gcc_StaticAssertType);
    PyModule_AddObject(m, "StaticAssert", (PyObject *)&gcc_StaticAssertType);

    Py_INCREF(&gcc_TypeArgumentPackType);
    PyModule_AddObject(m, "TypeArgumentPack", (PyObject *)&gcc_TypeArgumentPackType);

    Py_INCREF(&gcc_NontypeArgumentPackType);
    PyModule_AddObject(m, "NontypeArgumentPack", (PyObject *)&gcc_NontypeArgumentPackType);

    Py_INCREF(&gcc_TypePackExpansionType);
    PyModule_AddObject(m, "TypePackExpansion", (PyObject *)&gcc_TypePackExpansionType);

    Py_INCREF(&gcc_ExprPackExpansionType);
    PyModule_AddObject(m, "ExprPackExpansion", (PyObject *)&gcc_ExprPackExpansionType);

    Py_INCREF(&gcc_ArgumentPackSelectType);
    PyModule_AddObject(m, "ArgumentPackSelect", (PyObject *)&gcc_ArgumentPackSelectType);

    Py_INCREF(&gcc_TraitExprType);
    PyModule_AddObject(m, "TraitExpr", (PyObject *)&gcc_TraitExprType);

    Py_INCREF(&gcc_LambdaExprType);
    PyModule_AddObject(m, "LambdaExpr", (PyObject *)&gcc_LambdaExprType);

    Py_INCREF(&gcc_DecltypeTypeType);
    PyModule_AddObject(m, "DecltypeType", (PyObject *)&gcc_DecltypeTypeType);

    Py_INCREF(&gcc_UnderlyingTypeType);
    PyModule_AddObject(m, "UnderlyingType", (PyObject *)&gcc_UnderlyingTypeType);

    Py_INCREF(&gcc_BasesType);
    PyModule_AddObject(m, "Bases", (PyObject *)&gcc_BasesType);

    Py_INCREF(&gcc_TemplateInfoType);
    PyModule_AddObject(m, "TemplateInfo", (PyObject *)&gcc_TemplateInfoType);

    Py_INCREF(&gcc_UrshiftExprType);
    PyModule_AddObject(m, "UrshiftExpr", (PyObject *)&gcc_UrshiftExprType);

    Py_INCREF(&gcc_CompareExprType);
    PyModule_AddObject(m, "CompareExpr", (PyObject *)&gcc_CompareExprType);

    Py_INCREF(&gcc_CompareLExprType);
    PyModule_AddObject(m, "CompareLExpr", (PyObject *)&gcc_CompareLExprType);

    Py_INCREF(&gcc_CompareGExprType);
    PyModule_AddObject(m, "CompareGExpr", (PyObject *)&gcc_CompareGExprType);

    Py_INCREF(&gcc_ClassInterfaceTypeType);
    PyModule_AddObject(m, "ClassInterfaceType", (PyObject *)&gcc_ClassInterfaceTypeType);

    Py_INCREF(&gcc_ClassImplementationTypeType);
    PyModule_AddObject(m, "ClassImplementationType", (PyObject *)&gcc_ClassImplementationTypeType);

    Py_INCREF(&gcc_CategoryInterfaceTypeType);
    PyModule_AddObject(m, "CategoryInterfaceType", (PyObject *)&gcc_CategoryInterfaceTypeType);

    Py_INCREF(&gcc_CategoryImplementationTypeType);
    PyModule_AddObject(m, "CategoryImplementationType", (PyObject *)&gcc_CategoryImplementationTypeType);

    Py_INCREF(&gcc_ProtocolInterfaceTypeType);
    PyModule_AddObject(m, "ProtocolInterfaceType", (PyObject *)&gcc_ProtocolInterfaceTypeType);

    Py_INCREF(&gcc_KeywordDeclType);
    PyModule_AddObject(m, "KeywordDecl", (PyObject *)&gcc_KeywordDeclType);

    Py_INCREF(&gcc_InstanceMethodDeclType);
    PyModule_AddObject(m, "InstanceMethodDecl", (PyObject *)&gcc_InstanceMethodDeclType);

    Py_INCREF(&gcc_ClassMethodDeclType);
    PyModule_AddObject(m, "ClassMethodDecl", (PyObject *)&gcc_ClassMethodDeclType);

    Py_INCREF(&gcc_PropertyDeclType);
    PyModule_AddObject(m, "PropertyDecl", (PyObject *)&gcc_PropertyDeclType);

    Py_INCREF(&gcc_MessageSendExprType);
    PyModule_AddObject(m, "MessageSendExpr", (PyObject *)&gcc_MessageSendExprType);

    Py_INCREF(&gcc_ClassReferenceExprType);
    PyModule_AddObject(m, "ClassReferenceExpr", (PyObject *)&gcc_ClassReferenceExprType);

    Py_INCREF(&gcc_PropertyRefType);
    PyModule_AddObject(m, "PropertyRef", (PyObject *)&gcc_PropertyRefType);


}

